require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_SYS_PRIVREGS_H)) {
    eval 'sub _AMD64_SYS_PRIVREGS_H () {1;}' unless defined(&_AMD64_SYS_PRIVREGS_H);
    require 'sys/ccompile.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__amd64)) {
	die("non-amd64 code depends on amd64 privileged header!");
    }
    unless(defined(&_ASM)) {
	eval 'sub r_r0 () { &r_rax;}' unless defined(&r_r0);
	eval 'sub r_r1 () { &r_rdx;}' unless defined(&r_r1);
	eval 'sub r_fp () { &r_rbp;}' unless defined(&r_fp);
	eval 'sub r_sp () { &r_rsp;}' unless defined(&r_sp);
	eval 'sub r_pc () { &r_rip;}' unless defined(&r_pc);
	eval 'sub r_ps () { &r_rfl;}' unless defined(&r_ps);
	if(defined(&_KERNEL)) {
	    eval 'sub lwptoregs {
	        my($lwp) = @_;
    		eval q(((($lwp)-> &lwp_regs)));
	    }' unless defined(&lwptoregs);
	}
    } else {
	if(defined(&_MACHDEP)) {
	    require 'sys/machprivregs.ph';
	    require 'sys/pcb.ph';
	    if(defined(&DEBUG)  && !defined(&__xpv)) {
		eval 'sub __SAVE_BASES () { &movl $ &MSR_AMD_FSBASE, % &ecx;  &rdmsr;  &movl % &eax,  &REGOFF_FSBASE(% &rsp);  &movl % &edx,  &REGOFF_FSBASE+4(% &rsp);  &movl $ &MSR_AMD_GSBASE, % &ecx;  &rdmsr;  &movl % &eax,  &REGOFF_GSBASE(% &rsp);  &movl % &edx,  &REGOFF_GSBASE+4(% &rsp);}' unless defined(&__SAVE_BASES);
	    } else {
		eval 'sub __SAVE_BASES () {1;}' unless defined(&__SAVE_BASES);
	    }
	    eval 'sub __SAVE_REGS () { &movq % &r15,  &REGOFF_R15(% &rsp);  &movq % &r14,  &REGOFF_R14(% &rsp);  &movq % &r13,  &REGOFF_R13(% &rsp);  &movq % &r12,  &REGOFF_R12(% &rsp);  &movq % &r11,  &REGOFF_R11(% &rsp);  &movq % &r10,  &REGOFF_R10(% &rsp);  &movq % &rbp,  &REGOFF_RBP(% &rsp);  &movq % &rbx,  &REGOFF_RBX(% &rsp);  &movq % &rax,  &REGOFF_RAX(% &rsp);  &movq % &r9,  &REGOFF_R9(% &rsp);  &movq % &r8,  &REGOFF_R8(% &rsp);  &movq % &rcx,  &REGOFF_RCX(% &rsp);  &movq % &rdx,  &REGOFF_RDX(% &rsp);  &movq % &rsi,  &REGOFF_RSI(% &rsp);  &movq % &rdi,  &REGOFF_RDI(% &rsp);  &movq % &rbp,  &REGOFF_SAVFP(% &rsp);  &movq  &REGOFF_RIP(% &rsp), % &rcx;  &movq % &rcx,  &REGOFF_SAVPC(% &rsp);  &xorl % &ecx, % &ecx;  &movw % &gs, % &cx;  &movq % &rcx,  &REGOFF_GS(% &rsp);  &movw % &fs, % &cx;  &movq % &rcx,  &REGOFF_FS(% &rsp);  &movw % &es, % &cx;  &movq % &rcx,  &REGOFF_ES(% &rsp);  &movw % &ds, % &cx;  &movq % &rcx,  &REGOFF_DS(% &rsp);  &__SAVE_BASES;}' unless defined(&__SAVE_REGS);
	    eval 'sub __RESTORE_REGS () { &movq  &REGOFF_RDI(% &rsp), % &rdi;  &movq  &REGOFF_RSI(% &rsp), % &rsi;  &movq  &REGOFF_RDX(% &rsp), % &rdx;  &movq  &REGOFF_RCX(% &rsp), % &rcx;  &movq  &REGOFF_R8(% &rsp), % &r8;  &movq  &REGOFF_R9(% &rsp), % &r9;  &movq  &REGOFF_RAX(% &rsp), % &rax;  &movq  &REGOFF_RBX(% &rsp), % &rbx;  &movq  &REGOFF_RBP(% &rsp), % &rbp;  &movq  &REGOFF_R10(% &rsp), % &r10;  &movq  &REGOFF_R11(% &rsp), % &r11;  &movq  &REGOFF_R12(% &rsp), % &r12;  &movq  &REGOFF_R13(% &rsp), % &r13;  &movq  &REGOFF_R14(% &rsp), % &r14;  &movq  &REGOFF_R15(% &rsp), % &r15;}' unless defined(&__RESTORE_REGS);
	    eval 'sub INTR_PUSH () { &subq $ &REGOFF_TRAPNO, % &rsp;  &__SAVE_REGS;  &cmpw $ &KCS_SEL,  &REGOFF_CS(% &rsp);  &je 6 &f;  &movq $0,  &REGOFF_SAVFP(% &rsp);  &SWAPGS; 6:  &CLEAN_CS;}' unless defined(&INTR_PUSH);
	    eval 'sub INTR_POP () { &leaq  &sys_lcall32(% &rip), % &r11;  &cmpq % &r11,  &REGOFF_RIP(% &rsp);  &__RESTORE_REGS;  &je 5 &f;  &cmpw $ &KCS_SEL,  &REGOFF_CS(% &rsp);  &je 8 &f; 5:  &SWAPGS; 8:  &addq $ &REGOFF_RIP, % &rsp;}' unless defined(&INTR_POP);
	    eval 'sub USER_POP () { &__RESTORE_REGS;  &SWAPGS;  &addq $ &REGOFF_RIP, % &rsp;}' unless defined(&USER_POP);
	    eval 'sub USER32_POP () { &movl  &REGOFF_RDI(% &rsp), % &edi;  &movl  &REGOFF_RSI(% &rsp), % &esi;  &movl  &REGOFF_RDX(% &rsp), % &edx;  &movl  &REGOFF_RCX(% &rsp), % &ecx;  &movl  &REGOFF_RAX(% &rsp), % &eax;  &movl  &REGOFF_RBX(% &rsp), % &ebx;  &movl  &REGOFF_RBP(% &rsp), % &ebp;  &SWAPGS;  &addq $ &REGOFF_RIP, % &rsp;}' unless defined(&USER32_POP);
	    eval 'sub DFTRAP_PUSH () { &subq $ &REGOFF_TRAPNO, % &rsp;  &__SAVE_REGS;}' unless defined(&DFTRAP_PUSH);
	}
	eval 'sub INTGATE_INIT_KERNEL_FLAGS () { &pushq $ &F_OFF;  &popfq;}' unless defined(&INTGATE_INIT_KERNEL_FLAGS);
    }
    require 'sys/controlregs.ph';
    if(defined(&_KERNEL)  && !defined(&_ASM)) {
	if(!defined(&__lint)  && defined(&__GNUC__)) {
	} else {
	}
    }
    eval 'sub CREGSZ () {0x68;}' unless defined(&CREGSZ);
    eval 'sub CREG_GDT () {0;}' unless defined(&CREG_GDT);
    eval 'sub CREG_IDT () {0x10;}' unless defined(&CREG_IDT);
    eval 'sub CREG_LDT () {0x20;}' unless defined(&CREG_LDT);
    eval 'sub CREG_TASKR () {0x28;}' unless defined(&CREG_TASKR);
    eval 'sub CREG_CR0 () {0x30;}' unless defined(&CREG_CR0);
    eval 'sub CREG_CR2 () {0x38;}' unless defined(&CREG_CR2);
    eval 'sub CREG_CR3 () {0x40;}' unless defined(&CREG_CR3);
    eval 'sub CREG_CR4 () {0x48;}' unless defined(&CREG_CR4);
    eval 'sub CREG_CR8 () {0x50;}' unless defined(&CREG_CR8);
    eval 'sub CREG_KGSBASE () {0x58;}' unless defined(&CREG_KGSBASE);
    eval 'sub CREG_EFER () {0x60;}' unless defined(&CREG_EFER);
    if(!defined(&_ASM)  && defined(&_INT64_TYPE)) {
	if(defined(&_KERNEL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
