require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IA32_SYS_PRIVREGS_H)) {
    eval 'sub _IA32_SYS_PRIVREGS_H () {1;}' unless defined(&_IA32_SYS_PRIVREGS_H);
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__i386)) {
	die("non-i386 code depends on i386 privileged header!");
    }
    unless(defined(&_ASM)) {
	eval 'sub r_r0 () { &r_eax;}' unless defined(&r_r0);
	eval 'sub r_r1 () { &r_edx;}' unless defined(&r_r1);
	eval 'sub r_fp () { &r_ebp;}' unless defined(&r_fp);
	eval 'sub r_sp () { &r_uesp;}' unless defined(&r_sp);
	eval 'sub r_pc () { &r_eip;}' unless defined(&r_pc);
	eval 'sub r_ps () { &r_efl;}' unless defined(&r_ps);
	eval 'sub GREG_NUM () {8;}' unless defined(&GREG_NUM);
	if(defined(&_KERNEL)) {
	    eval 'sub lwptoregs {
	        my($lwp) = @_;
    		eval q(((($lwp)-> &lwp_regs)));
	    }' unless defined(&lwptoregs);
	}
    } else {
	if(defined(&_MACHDEP)) {
	    require 'sys/machprivregs.ph';
	    eval 'sub __FRAME_PUSH () { &subl $8, % &esp;  &movl  &REGOFF_EIP(% &esp), % &eax;  &movl % &eax,  &REGOFF_SAVPC(% &esp);  &movl % &ebp,  &REGOFF_SAVFP(% &esp);;}' unless defined(&__FRAME_PUSH);
	    eval 'sub __SEGREGS_PUSH () { &subl $16, % &esp;  &movw % &ds, 12(% &esp);  &movw % &es, 8(% &esp);  &movw % &fs, 4(% &esp);  &movw % &gs, 0(% &esp);;}' unless defined(&__SEGREGS_PUSH);
	    eval 'sub __SEGREGS_LOAD_KERNEL () { &movw $ &KDS_SEL, % &cx;  &movw % &cx, % &ds;  &movw % &cx, % &es;  &movw $ &KFS_SEL, % &cx;  &movw $ &KGS_SEL, % &dx;  &movw % &cx, % &fs;  &movw % &dx, % &gs;;}' unless defined(&__SEGREGS_LOAD_KERNEL);
	    eval 'sub __SEGREGS_POP () { &movw 0(% &esp), % &gs;  &movw 4(% &esp), % &fs;  &movw 8(% &esp), % &es;  &movw 12(% &esp), % &ds;  &addl $16, % &esp;;}' unless defined(&__SEGREGS_POP);
	    eval 'sub INTR_PUSH () { &cld;  &pusha;  &__SEGREGS_PUSH  &__FRAME_PUSH  &cmpw $ &KGS_SEL,  &REGOFF_GS(% &esp);  &je 8 &f;  &movl $0,  &REGOFF_SAVFP(% &esp);  &__SEGREGS_LOAD_KERNEL 8:  &CLEAN_CS;}' unless defined(&INTR_PUSH);
	    eval 'sub __INTR_POP () { &popa;  &addl $8, % &esp;;}' unless defined(&__INTR_POP);
	    eval 'sub INTR_POP_USER () { &addl $8, % &esp;  &__SEGREGS_POP  &__INTR_POP;}' unless defined(&INTR_POP_USER);
	    eval 'sub INTR_POP_KERNEL () { &addl $24, % &esp;  &__INTR_POP;}' unless defined(&INTR_POP_KERNEL);
	    eval 'sub SYSCALL_PUSH () { &cld;  &pusha;  &__SEGREGS_PUSH  &subl $8, % &esp;  &pushfl;  &popl % &ecx;  &orl $ &PS_IE, % &ecx;  &movl % &ecx,  &REGOFF_EFL(% &esp);  &movl $0,  &REGOFF_SAVPC(% &esp);  &movl $0,  &REGOFF_SAVFP(% &esp);  &__SEGREGS_LOAD_KERNEL;;}' unless defined(&SYSCALL_PUSH);
	    eval 'sub SYSENTER_PUSH () { &cld;  &pusha;  &__SEGREGS_PUSH  &subl $8, % &esp;  &movl $0,  &REGOFF_SAVPC(% &esp);  &movl $0,  &REGOFF_SAVFP(% &esp);  &__SEGREGS_LOAD_KERNEL;}' unless defined(&SYSENTER_PUSH);
	    eval 'sub SYSCALL_POP () { &INTR_POP_USER;}' unless defined(&SYSCALL_POP);
	}
	eval 'sub INTGATE_INIT_KERNEL_FLAGS () { &pushl $ &F_OFF;  &popfl;}' unless defined(&INTGATE_INIT_KERNEL_FLAGS);
    }
    require 'sys/controlregs.ph';
    eval 'sub CREGSZ () {36;}' unless defined(&CREGSZ);
    eval 'sub CREG_GDT () {0;}' unless defined(&CREG_GDT);
    eval 'sub CREG_IDT () {8;}' unless defined(&CREG_IDT);
    eval 'sub CREG_LDT () {16;}' unless defined(&CREG_LDT);
    eval 'sub CREG_TASKR () {18;}' unless defined(&CREG_TASKR);
    eval 'sub CREG_CR0 () {20;}' unless defined(&CREG_CR0);
    eval 'sub CREG_CR2 () {24;}' unless defined(&CREG_CR2);
    eval 'sub CREG_CR3 () {28;}' unless defined(&CREG_CR3);
    eval 'sub CREG_CR4 () {32;}' unless defined(&CREG_CR4);
    if(!defined(&_ASM)  && defined(&_INT64_TYPE)) {
	if(defined(&_KERNEL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
