require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_BITMAP_H)) {
    eval 'sub _SYS_BITMAP_H () {1;}' unless defined(&_SYS_BITMAP_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/feature_tests.ph';
    if(defined(&__GNUC__)  && defined(&_ASM_INLINES)  && (defined(&__i386) || defined(&__amd64))) {
	require 'asm/bitmap.ph';
    }
    if(defined(&_LP64)) {
	eval 'sub BT_ULSHIFT () {6;}' unless defined(&BT_ULSHIFT);
	eval 'sub BT_ULSHIFT32 () {5;}' unless defined(&BT_ULSHIFT32);
    } else {
	eval 'sub BT_ULSHIFT () {5;}' unless defined(&BT_ULSHIFT);
    }
    eval 'sub BT_NBIPUL () {(1<<  &BT_ULSHIFT);}' unless defined(&BT_NBIPUL);
    eval 'sub BT_ULMASK () {( &BT_NBIPUL - 1);}' unless defined(&BT_ULMASK);
    if(defined(&_LP64)) {
	eval 'sub BT_NBIPUL32 () {(1<<  &BT_ULSHIFT32);}' unless defined(&BT_NBIPUL32);
	eval 'sub BT_ULMASK32 () {( &BT_NBIPUL32 - 1);}' unless defined(&BT_ULMASK32);
	eval 'sub BT_ULMAXMASK () {0xffffffffffffffff;}' unless defined(&BT_ULMAXMASK);
    } else {
	eval 'sub BT_ULMAXMASK () {0xffffffff;}' unless defined(&BT_ULMAXMASK);
    }
    eval 'sub BT_WIM {
        my($bitmap, $bitindex) = @_;
	    eval q((($bitmap)[($bitindex) >>  &BT_ULSHIFT]));
    }' unless defined(&BT_WIM);
    eval 'sub BT_BIW {
        my($bitindex) = @_;
	    eval q((1 << (($bitindex) &  &BT_ULMASK)));
    }' unless defined(&BT_BIW);
    if(defined(&_LP64)) {
	eval 'sub BT_WIM32 {
	    my($bitmap, $bitindex) = @_;
    	    eval q((($bitmap)[($bitindex) >>  &BT_ULSHIFT32]));
	}' unless defined(&BT_WIM32);
	eval 'sub BT_BIW32 {
	    my($bitindex) = @_;
    	    eval q((1 << (($bitindex) &  &BT_ULMASK32)));
	}' unless defined(&BT_BIW32);
    }
    eval 'sub BT_BITOUL {
        my($nbits) = @_;
	    eval q(((($nbits) +  &BT_NBIPUL - 1) /  &BT_NBIPUL));
    }' unless defined(&BT_BITOUL);
    eval 'sub BT_SIZEOFMAP {
        my($nbits) = @_;
	    eval q(( &BT_BITOUL($nbits) * $sizeof{\'ulong_t\'}));
    }' unless defined(&BT_SIZEOFMAP);
    eval 'sub BT_TEST {
        my($bitmap, $bitindex) = @_;
	    eval q((( &BT_WIM(($bitmap), ($bitindex)) &  &BT_BIW($bitindex)) ? 1: 0));
    }' unless defined(&BT_TEST);
    eval 'sub BT_SET {
        my($bitmap, $bitindex) = @_;
	    eval q({  &BT_WIM(($bitmap), ($bitindex)) |=  &BT_BIW($bitindex); });
    }' unless defined(&BT_SET);
    eval 'sub BT_CLEAR {
        my($bitmap, $bitindex) = @_;
	    eval q({  &BT_WIM(($bitmap), ($bitindex)) &= ~ &BT_BIW($bitindex); });
    }' unless defined(&BT_CLEAR);
    if(defined(&_LP64)) {
	eval 'sub BT_BITOUL32 {
	    my($nbits) = @_;
    	    eval q(((($nbits) +  &BT_NBIPUL32 - 1) /  &BT_NBIPUL32));
	}' unless defined(&BT_BITOUL32);
	eval 'sub BT_SIZEOFMAP32 {
	    my($nbits) = @_;
    	    eval q(( &BT_BITOUL32($nbits) * $sizeof{ &uint_t}));
	}' unless defined(&BT_SIZEOFMAP32);
	eval 'sub BT_TEST32 {
	    my($bitmap, $bitindex) = @_;
    	    eval q((( &BT_WIM32(($bitmap), ($bitindex)) &  &BT_BIW32($bitindex)) ? 1: 0));
	}' unless defined(&BT_TEST32);
	eval 'sub BT_SET32 {
	    my($bitmap, $bitindex) = @_;
    	    eval q({  &BT_WIM32(($bitmap), ($bitindex)) |=  &BT_BIW32($bitindex); });
	}' unless defined(&BT_SET32);
	eval 'sub BT_CLEAR32 {
	    my($bitmap, $bitindex) = @_;
    	    eval q({  &BT_WIM32(($bitmap), ($bitindex)) &= ~ &BT_BIW32($bitindex); });
	}' unless defined(&BT_CLEAR32);
    }
    eval 'sub BIT_ONLYONESET {
        my($u) = @_;
	    eval q((((($u) == 0) ? 0: (($u) & (($u) - 1)) == 0)));
    }' unless defined(&BIT_ONLYONESET);
    if(defined(&_KERNEL)  && !defined(&_ASM)) {
	require 'sys/atomic.ph';
	eval 'sub BT_ATOMIC_SET {
	    my($bitmap, $bitindex) = @_;
    	    eval q({  &atomic_or_ulong(( &BT_WIM($bitmap, $bitindex)),  &BT_BIW($bitindex)); });
	}' unless defined(&BT_ATOMIC_SET);
	eval 'sub BT_ATOMIC_CLEAR {
	    my($bitmap, $bitindex) = @_;
    	    eval q({  &atomic_and_ulong(( &BT_WIM($bitmap, $bitindex)), ~ &BT_BIW($bitindex)); });
	}' unless defined(&BT_ATOMIC_CLEAR);
	eval 'sub BT_ATOMIC_SET_EXCL {
	    my($bitmap, $bitindex, $result) = @_;
    	    eval q({ $result =  &atomic_set_long_excl(( &BT_WIM($bitmap, $bitindex)), ($bitindex) %  &BT_NBIPUL); });
	}' unless defined(&BT_ATOMIC_SET_EXCL);
	eval 'sub BT_ATOMIC_CLEAR_EXCL {
	    my($bitmap, $bitindex, $result) = @_;
    	    eval q({ $result =  &atomic_clear_long_excl(( &BT_WIM($bitmap, $bitindex)), ($bitindex) %  &BT_NBIPUL); });
	}' unless defined(&BT_ATOMIC_CLEAR_EXCL);
	eval 'sub BITX {
	    my($u, $h, $l) = @_;
    	    eval q(((($u) >> ($l)) & ((1 << (($h) - ($l) + 1)) - 1)));
	}' unless defined(&BITX);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
