require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_BUF_H)) {
    eval 'sub _SYS_BUF_H () {1;}' unless defined(&_SYS_BUF_H);
    require 'sys/types32.ph';
    require 'sys/t_lock.ph';
    require 'sys/kstat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub b_lblkno () { ($_b_blkno->{_f});}' unless defined(&b_lblkno);
    if(defined(&_LP64)) {
	eval 'sub b_blkno () { ($_b_blkno->{_f});}' unless defined(&b_blkno);
    } else {
	eval 'sub b_blkno () { ($_b_blkno->{_p}->{_l});}' unless defined(&b_blkno);
    }
    eval 'sub b_actf () { &av_forw;}' unless defined(&b_actf);
    eval 'sub b_actl () { &av_back;}' unless defined(&b_actl);
    eval 'sub b_active () { &b_bcount;}' unless defined(&b_active);
    eval 'sub b_errcnt () { &b_resid;}' unless defined(&b_errcnt);
    eval 'sub B_BUSY () {0x1;}' unless defined(&B_BUSY);
    eval 'sub B_DONE () {0x2;}' unless defined(&B_DONE);
    eval 'sub B_ERROR () {0x4;}' unless defined(&B_ERROR);
    eval 'sub B_PAGEIO () {0x10;}' unless defined(&B_PAGEIO);
    eval 'sub B_PHYS () {0x20;}' unless defined(&B_PHYS);
    eval 'sub B_READ () {0x40;}' unless defined(&B_READ);
    eval 'sub B_WRITE () {0x100;}' unless defined(&B_WRITE);
    eval 'sub B_WANTED () {0x80;}' unless defined(&B_WANTED);
    eval 'sub B_AGE () {0x200;}' unless defined(&B_AGE);
    eval 'sub B_ASYNC () {0x400;}' unless defined(&B_ASYNC);
    eval 'sub B_DELWRI () {0x800;}' unless defined(&B_DELWRI);
    eval 'sub B_STALE () {0x1000;}' unless defined(&B_STALE);
    eval 'sub B_DONTNEED () {0x2000;}' unless defined(&B_DONTNEED);
    eval 'sub B_REMAPPED () {0x4000;}' unless defined(&B_REMAPPED);
    eval 'sub B_FREE () {0x8000;}' unless defined(&B_FREE);
    eval 'sub B_INVAL () {0x10000;}' unless defined(&B_INVAL);
    eval 'sub B_FORCE () {0x20000;}' unless defined(&B_FORCE);
    eval 'sub B_NOCACHE () {0x80000;}' unless defined(&B_NOCACHE);
    eval 'sub B_TRUNC () {0x100000;}' unless defined(&B_TRUNC);
    eval 'sub B_SHADOW () {0x200000;}' unless defined(&B_SHADOW);
    eval 'sub B_RETRYWRI () {0x400000;}' unless defined(&B_RETRYWRI);
    eval 'sub B_FAILFAST () {0x1000000;}' unless defined(&B_FAILFAST);
    eval 'sub B_STARTED () {0x2000000;}' unless defined(&B_STARTED);
    eval 'sub B_ABRWRITE () {0x4000000;}' unless defined(&B_ABRWRITE);
    eval 'sub B_PAGE_NOWAIT () {0x8000000;}' unless defined(&B_PAGE_NOWAIT);
    eval 'sub bremhash {
        my($bp) = @_;
	    eval q({  &ASSERT(($bp)-> &b_forw !=  &NULL);  &ASSERT(($bp)-> &b_back !=  &NULL); ($bp)-> ($b_back->{b_forw}) = ($bp)-> &b_forw; ($bp)-> ($b_forw->{b_back}) = ($bp)-> &b_back; ($bp)-> &b_forw = ($bp)-> &b_back =  &NULL; });
    }' unless defined(&bremhash);
    eval 'sub binshash {
        my($bp, $dp) = @_;
	    eval q({  &ASSERT(($bp)-> &b_forw ==  &NULL);  &ASSERT(($bp)-> &b_back ==  &NULL);  &ASSERT(($dp)-> &b_forw !=  &NULL);  &ASSERT(($dp)-> &b_back !=  &NULL); ($bp)-> &b_forw = ($dp)-> &b_forw; ($bp)-> &b_back = ($dp); ($dp)-> ($b_forw->{b_back}) = ($bp); ($dp)-> &b_forw = ($bp); });
    }' unless defined(&binshash);
    eval 'sub notavail {
        my($bp) = @_;
	    eval q({  &ASSERT( &SEMA_HELD( ($bp->{b_sem})));  &ASSERT(($bp)-> &av_forw !=  &NULL);  &ASSERT(($bp)-> &av_back !=  &NULL);  &ASSERT(($bp)-> &av_forw != ($bp));  &ASSERT(($bp)-> &av_back != ($bp)); ($bp)-> ($av_back->{av_forw}) = ($bp)-> &av_forw; ($bp)-> ($av_forw->{av_back}) = ($bp)-> &av_back; ($bp)-> &b_flags |=  &B_BUSY; ($bp)-> &av_forw = ($bp)-> &av_back =  &NULL; });
    }' unless defined(&notavail);
    if(defined(&_KERNEL)) {
	eval 'sub BREAD {
	    my($dev, $blkno, $bsize) = @_;
    	    eval q( &bread_common(  &NULL, $dev, $blkno, $bsize));
	}' unless defined(&BREAD);
	eval 'sub BWRITE {
	    my($bp) = @_;
    	    eval q( &bwrite_common(  &NULL, $bp, 0, 1, ( &B_READ |  &B_DONE |  &B_ERROR |  &B_DELWRI)));
	}' unless defined(&BWRITE);
	eval 'sub BWRITE2 {
	    my($bp) = @_;
    	    eval q( &bwrite_common(  &NULL, $bp, 1, 0, ( &B_READ |  &B_DONE |  &B_ERROR |  &B_DELWRI)));
	}' unless defined(&BWRITE2);
	eval 'sub GETBLK {
	    my($dev, $blkno, $bsize) = @_;
    	    eval q( &getblk_common(  &NULL, $dev, $blkno, $bsize, 0));
	}' unless defined(&GETBLK);
	eval 'sub bdrwrite {
	    my($bp) = @_;
    	    eval q({ ($bp)-> &b_flags |=  &B_RETRYWRI;  &bdwrite(($bp)); });
	}' unless defined(&bdrwrite);
	eval 'sub brwrite {
	    my($bp) = @_;
    	    eval q({ ($bp)-> &b_flags |=  &B_RETRYWRI;  &bwrite_common(($bp), 0, 1, ( &B_READ |  &B_DONE |  &B_ERROR |  &B_DELWRI)); });
	}' unless defined(&brwrite);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
