require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_BYTEORDER_H)) {
    eval 'sub _SYS_BYTEORDER_H () {1;}' unless defined(&_SYS_BYTEORDER_H);
    require 'sys/isa_defs.ph';
    require 'sys/int_types.ph';
    if(defined(&__GNUC__)  && defined(&_ASM_INLINES)  && (defined(&__i386) || defined(&__amd64))) {
	require 'asm/byteorder.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_BIG_ENDIAN)  && !defined(&ntohl)  && !defined(&__lint)) {
	eval 'sub ntohl {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ntohl);
	eval 'sub ntohs {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ntohs);
	eval 'sub htonl {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&htonl);
	eval 'sub htons {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&htons);
	if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    eval 'sub ntohll {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&ntohll);
	    eval 'sub htonll {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&htonll);
	}
    }
 elsif(!defined(&ntohl) ) {
	unless(defined(&_IN_PORT_T)) {
	    eval 'sub _IN_PORT_T () {1;}' unless defined(&_IN_PORT_T);
	}
	unless(defined(&_IN_ADDR_T)) {
	    eval 'sub _IN_ADDR_T () {1;}' unless defined(&_IN_ADDR_T);
	}
	if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__) || defined(&_XPG5)) {
	} else {
	}
	if(defined(&_LP64) || defined(&_LONGLONG_TYPE)) {
	    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    }
	}
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub BSWAP_8 {
	    my($x) = @_;
    	    eval q((($x) & 0xff));
	}' unless defined(&BSWAP_8);
	if(!defined(&__i386)  && !defined(&__amd64)) {
	    eval 'sub BSWAP_16 {
	        my($x) = @_;
    		eval q((( &BSWAP_8($x) << 8) |  &BSWAP_8(($x) >> 8)));
	    }' unless defined(&BSWAP_16);
	    eval 'sub BSWAP_32 {
	        my($x) = @_;
    		eval q(((( &uint32_t)($x) << 24) | ((( &uint32_t)($x) << 8) & 0xff0000) | ((( &uint32_t)($x) >> 8) & 0xff00) | (( &uint32_t)($x) >> 24)));
	    }' unless defined(&BSWAP_32);
	} else {
	    eval 'sub BSWAP_16 {
	        my($x) = @_;
    		eval q( &htons($x));
	    }' unless defined(&BSWAP_16);
	    eval 'sub BSWAP_32 {
	        my($x) = @_;
    		eval q( &htonl($x));
	    }' unless defined(&BSWAP_32);
	}
	if(defined(&_LP64) || defined(&_LONGLONG_TYPE)) {
	    if((!defined(&__i386)  && !defined(&__amd64))) {
		eval 'sub BSWAP_64 {
		    my($x) = @_;
    		    eval q(((( &uint64_t)($x) << 56) | ((( &uint64_t)($x) << 40) & 0xff000000000000) | ((( &uint64_t)($x) << 24) & 0xff0000000000) | ((( &uint64_t)($x) << 8) & 0xff00000000) | ((( &uint64_t)($x) >> 8) & 0xff000000) | ((( &uint64_t)($x) >> 24) & 0xff0000) | ((( &uint64_t)($x) >> 40) & 0xff00) | (( &uint64_t)($x) >> 56)));
		}' unless defined(&BSWAP_64);
	    } else {
		eval 'sub BSWAP_64 {
		    my($x) = @_;
    		    eval q( &htonll($x));
		}' unless defined(&BSWAP_64);
	    }
	} else {
	    eval 'sub BSWAP_64 {
	        my($x) = @_;
    		eval q((( &BSWAP_32($x) << 32) |  &BSWAP_32(($x) >> 32)));
	    }' unless defined(&BSWAP_64);
	}
	eval 'sub BMASK_8 {
	    my($x) = @_;
    	    eval q((($x) & 0xff));
	}' unless defined(&BMASK_8);
	eval 'sub BMASK_16 {
	    my($x) = @_;
    	    eval q((($x) & 0xffff));
	}' unless defined(&BMASK_16);
	eval 'sub BMASK_32 {
	    my($x) = @_;
    	    eval q((($x) & 0xffffffff));
	}' unless defined(&BMASK_32);
	eval 'sub BMASK_64 {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&BMASK_64);
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub BE_8 {
	        my($x) = @_;
    		eval q( &BMASK_8($x));
	    }' unless defined(&BE_8);
	    eval 'sub BE_16 {
	        my($x) = @_;
    		eval q( &BMASK_16($x));
	    }' unless defined(&BE_16);
	    eval 'sub BE_32 {
	        my($x) = @_;
    		eval q( &BMASK_32($x));
	    }' unless defined(&BE_32);
	    eval 'sub BE_64 {
	        my($x) = @_;
    		eval q( &BMASK_64($x));
	    }' unless defined(&BE_64);
	    eval 'sub LE_8 {
	        my($x) = @_;
    		eval q( &BSWAP_8($x));
	    }' unless defined(&LE_8);
	    eval 'sub LE_16 {
	        my($x) = @_;
    		eval q( &BSWAP_16($x));
	    }' unless defined(&LE_16);
	    eval 'sub LE_32 {
	        my($x) = @_;
    		eval q( &BSWAP_32($x));
	    }' unless defined(&LE_32);
	    eval 'sub LE_64 {
	        my($x) = @_;
    		eval q( &BSWAP_64($x));
	    }' unless defined(&LE_64);
	} else {
	    eval 'sub LE_8 {
	        my($x) = @_;
    		eval q( &BMASK_8($x));
	    }' unless defined(&LE_8);
	    eval 'sub LE_16 {
	        my($x) = @_;
    		eval q( &BMASK_16($x));
	    }' unless defined(&LE_16);
	    eval 'sub LE_32 {
	        my($x) = @_;
    		eval q( &BMASK_32($x));
	    }' unless defined(&LE_32);
	    eval 'sub LE_64 {
	        my($x) = @_;
    		eval q( &BMASK_64($x));
	    }' unless defined(&LE_64);
	    eval 'sub BE_8 {
	        my($x) = @_;
    		eval q( &BSWAP_8($x));
	    }' unless defined(&BE_8);
	    eval 'sub BE_16 {
	        my($x) = @_;
    		eval q( &BSWAP_16($x));
	    }' unless defined(&BE_16);
	    eval 'sub BE_32 {
	        my($x) = @_;
    		eval q( &BSWAP_32($x));
	    }' unless defined(&BE_32);
	    eval 'sub BE_64 {
	        my($x) = @_;
    		eval q( &BSWAP_64($x));
	    }' unless defined(&BE_64);
	}
	eval 'sub BE_IN8 {
	    my($xa) = @_;
    	    eval q(*(( &uint8_t *)($xa)));
	}' unless defined(&BE_IN8);
	if(!defined(&__i386)  && !defined(&__amd64)) {
	    eval 'sub BE_IN16 {
	        my($xa) = @_;
    		eval q(((( &uint16_t) &BE_IN8($xa) << 8) |  &BE_IN8(( &uint8_t *)($xa) + 1)));
	    }' unless defined(&BE_IN16);
	    eval 'sub BE_IN32 {
	        my($xa) = @_;
    		eval q(((( &uint32_t) &BE_IN16($xa) << 16) |  &BE_IN16(( &uint8_t *)($xa) + 2)));
	    }' unless defined(&BE_IN32);
	} else {
	    eval 'sub BE_IN16 {
	        my($xa) = @_;
    		eval q( &htons(*(( &uint16_t *)( &void *)($xa))));
	    }' unless defined(&BE_IN16);
	    eval 'sub BE_IN32 {
	        my($xa) = @_;
    		eval q( &htonl(*(( &uint32_t *)( &void *)($xa))));
	    }' unless defined(&BE_IN32);
	}
	if((!defined(&__i386)  && !defined(&__amd64)) || (!defined(&_LP64)  && !defined(&_LONGLONG_TYPE))) {
	    eval 'sub BE_IN64 {
	        my($xa) = @_;
    		eval q(((( &uint64_t) &BE_IN32($xa) << 32) |  &BE_IN32(( &uint8_t *)($xa) + 4)));
	    }' unless defined(&BE_IN64);
	} else {
	    eval 'sub BE_IN64 {
	        my($xa) = @_;
    		eval q( &htonll(*(( &uint64_t *)( &void *)($xa))));
	    }' unless defined(&BE_IN64);
	}
	eval 'sub LE_IN8 {
	    my($xa) = @_;
    	    eval q(*(( &uint8_t *)($xa)));
	}' unless defined(&LE_IN8);
	eval 'sub LE_IN16 {
	    my($xa) = @_;
    	    eval q(((( &uint16_t) &LE_IN8(( &uint8_t *)($xa) + 1) << 8) |  &LE_IN8($xa)));
	}' unless defined(&LE_IN16);
	eval 'sub LE_IN32 {
	    my($xa) = @_;
    	    eval q(((( &uint32_t) &LE_IN16(( &uint8_t *)($xa) + 2) << 16) |  &LE_IN16($xa)));
	}' unless defined(&LE_IN32);
	eval 'sub LE_IN64 {
	    my($xa) = @_;
    	    eval q(((( &uint64_t) &LE_IN32(( &uint8_t *)($xa) + 4) << 32) |  &LE_IN32($xa)));
	}' unless defined(&LE_IN64);
	eval 'sub BE_OUT8 {
	    my($xa, $yv) = @_;
    	    eval q(*(( &uint8_t *)($xa)) = ( &uint8_t)($yv););
	}' unless defined(&BE_OUT8);
	eval 'sub BE_OUT16 {
	    my($xa, $yv) = @_;
    	    eval q( &BE_OUT8(( &uint8_t *)($xa) + 1, $yv);  &BE_OUT8(( &uint8_t *)($xa), ($yv) >> 8););
	}' unless defined(&BE_OUT16);
	eval 'sub BE_OUT32 {
	    my($xa, $yv) = @_;
    	    eval q( &BE_OUT16(( &uint8_t *)($xa) + 2, $yv);  &BE_OUT16(( &uint8_t *)($xa), ($yv) >> 16););
	}' unless defined(&BE_OUT32);
	if((!defined(&__i386)  && !defined(&__amd64)) || (!defined(&_LP64)  && !defined(&_LONGLONG_TYPE))) {
	    eval 'sub BE_OUT64 {
	        my($xa, $yv) = @_;
    		eval q( &BE_OUT32(( &uint8_t *)($xa) + 4, $yv);  &BE_OUT32(( &uint8_t *)($xa), ($yv) >> 32););
	    }' unless defined(&BE_OUT64);
	} else {
	    eval 'sub BE_OUT64 {
	        my($xa, $yv) = @_;
    		eval q(*(( &uint64_t *)( &void *)($xa)) =  &htonll(( &uint64_t)($yv)););
	    }' unless defined(&BE_OUT64);
	}
	eval 'sub LE_OUT8 {
	    my($xa, $yv) = @_;
    	    eval q(*(( &uint8_t *)($xa)) = ( &uint8_t)($yv););
	}' unless defined(&LE_OUT8);
	eval 'sub LE_OUT16 {
	    my($xa, $yv) = @_;
    	    eval q( &LE_OUT8(( &uint8_t *)($xa), $yv);  &LE_OUT8(( &uint8_t *)($xa) + 1, ($yv) >> 8););
	}' unless defined(&LE_OUT16);
	eval 'sub LE_OUT32 {
	    my($xa, $yv) = @_;
    	    eval q( &LE_OUT16(( &uint8_t *)($xa), $yv);  &LE_OUT16(( &uint8_t *)($xa) + 2, ($yv) >> 16););
	}' unless defined(&LE_OUT32);
	eval 'sub LE_OUT64 {
	    my($xa, $yv) = @_;
    	    eval q( &LE_OUT32(( &uint8_t *)($xa), $yv);  &LE_OUT32(( &uint8_t *)($xa) + 4, ($yv) >> 32););
	}' unless defined(&LE_OUT64);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
