require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CPUVAR_H)) {
    eval 'sub _SYS_CPUVAR_H () {1;}' unless defined(&_SYS_CPUVAR_H);
    require 'sys/thread.ph';
    require 'sys/sysinfo.ph';
    require 'sys/disp.ph';
    require 'sys/processor.ph';
    require 'sys/loadavg.ph';
    if((defined(&_KERNEL) || defined(&_KMEMUSER))  && defined(&_MACHDEP)) {
	require 'sys/machcpuvar.ph';
    }
    require 'sys/types.ph';
    require 'sys/file.ph';
    require 'sys/bitmap.ph';
    require 'sys/rwlock.ph';
    require 'sys/msacct.ph';
    if(defined(&__GNUC__)  && defined(&_ASM_INLINES)  && defined(&_KERNEL)  && (defined(&__i386) || defined(&__amd64))) {
	require 'asm/cpuvar.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub CPU_CACHE_COHERENCE_SIZE () {64;}' unless defined(&CPU_CACHE_COHERENCE_SIZE);
    if((defined(&_KERNEL) || defined(&_KMEMUSER))  && defined(&_MACHDEP)) {
    }
    eval 'sub CPUC_SIZE () {($sizeof{ &uint16_t} + $sizeof{ &uint8_t} + $sizeof{ &uintptr_t} + $sizeof{ &kmutex_t});}' unless defined(&CPUC_SIZE);
    eval 'sub CPUC_PADSIZE () { &CPU_CACHE_COHERENCE_SIZE -  &CPUC_SIZE;}' unless defined(&CPUC_PADSIZE);
    if(defined(&_KERNEL)) {
    }
    eval 'sub CPU_ON_INTR {
        my($cpup) = @_;
	    eval q((($cpup)-> &cpu_intr_actv >> ( &LOCK_LEVEL + 1)));
    }' unless defined(&CPU_ON_INTR);
    eval 'sub INTR_ACTIVE {
        my($cpup, $level) = @_;
	    eval q((($level) <=  &LOCK_LEVEL ? (($cpup)-> &cpu_intr_actv & (1<< ($level))) : ( &CPU_ON_INTR($cpup))));
    }' unless defined(&INTR_ACTIVE);
    eval 'sub CPU_PSEUDO_RANDOM () {
        eval q(( ($CPU->{cpu_rotor})++));
    }' unless defined(&CPU_PSEUDO_RANDOM);
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	eval 'sub INTR_STACK_SIZE () { &MAX( &DEFAULTSTKSZ,  &PAGESIZE);}' unless defined(&INTR_STACK_SIZE);
	eval 'sub CPU_RUNNING () {0x1;}' unless defined(&CPU_RUNNING);
	eval 'sub CPU_READY () {0x2;}' unless defined(&CPU_READY);
	eval 'sub CPU_QUIESCED () {0x4;}' unless defined(&CPU_QUIESCED);
	eval 'sub CPU_EXISTS () {0x8;}' unless defined(&CPU_EXISTS);
	eval 'sub CPU_ENABLE () {0x10;}' unless defined(&CPU_ENABLE);
	eval 'sub CPU_OFFLINE () {0x20;}' unless defined(&CPU_OFFLINE);
	eval 'sub CPU_POWEROFF () {0x40;}' unless defined(&CPU_POWEROFF);
	eval 'sub CPU_FROZEN () {0x80;}' unless defined(&CPU_FROZEN);
	eval 'sub CPU_SPARE () {0x100;}' unless defined(&CPU_SPARE);
	eval 'sub CPU_FAULTED () {0x200;}' unless defined(&CPU_FAULTED);
	eval 'sub FMT_CPU_FLAGS () {"\\20\\12fault\\11spare\\10frozen" "\\7poweroff\\6offline\\5enable\\4exist\\3quiesced\\2ready\\1run";}' unless defined(&FMT_CPU_FLAGS);
	eval 'sub CPU_ACTIVE {
	    my($cpu) = @_;
    	    eval q(((($cpu)-> &cpu_flags &  &CPU_OFFLINE) == 0));
	}' unless defined(&CPU_ACTIVE);
	eval 'sub CPU_FORCED () {0x1;}' unless defined(&CPU_FORCED);
	eval 'sub CPU_DTRACE_NOFAULT () {0x1;}' unless defined(&CPU_DTRACE_NOFAULT);
	eval 'sub CPU_DTRACE_DROP () {0x2;}' unless defined(&CPU_DTRACE_DROP);
	eval 'sub CPU_DTRACE_BADADDR () {0x4;}' unless defined(&CPU_DTRACE_BADADDR);
	eval 'sub CPU_DTRACE_BADALIGN () {0x8;}' unless defined(&CPU_DTRACE_BADALIGN);
	eval 'sub CPU_DTRACE_DIVZERO () {0x10;}' unless defined(&CPU_DTRACE_DIVZERO);
	eval 'sub CPU_DTRACE_ILLOP () {0x20;}' unless defined(&CPU_DTRACE_ILLOP);
	eval 'sub CPU_DTRACE_NOSCRATCH () {0x40;}' unless defined(&CPU_DTRACE_NOSCRATCH);
	eval 'sub CPU_DTRACE_KPRIV () {0x80;}' unless defined(&CPU_DTRACE_KPRIV);
	eval 'sub CPU_DTRACE_UPRIV () {0x100;}' unless defined(&CPU_DTRACE_UPRIV);
	eval 'sub CPU_DTRACE_TUPOFLOW () {0x200;}' unless defined(&CPU_DTRACE_TUPOFLOW);
	if(defined(&__sparc)) {
	    eval 'sub CPU_DTRACE_FAKERESTORE () {0x400;}' unless defined(&CPU_DTRACE_FAKERESTORE);
	}
	eval 'sub CPU_DTRACE_ENTRY () {0x800;}' unless defined(&CPU_DTRACE_ENTRY);
	eval 'sub CPU_DTRACE_BADSTACK () {0x1000;}' unless defined(&CPU_DTRACE_BADSTACK);
	eval 'sub CPU_DTRACE_FAULT () {( &CPU_DTRACE_BADADDR |  &CPU_DTRACE_BADALIGN |  &CPU_DTRACE_DIVZERO |  &CPU_DTRACE_ILLOP |  &CPU_DTRACE_NOSCRATCH |  &CPU_DTRACE_KPRIV |  &CPU_DTRACE_UPRIV |  &CPU_DTRACE_TUPOFLOW |  &CPU_DTRACE_BADSTACK);}' unless defined(&CPU_DTRACE_FAULT);
	eval 'sub CPU_DTRACE_ERROR () {( &CPU_DTRACE_FAULT |  &CPU_DTRACE_DROP);}' unless defined(&CPU_DTRACE_ERROR);
	eval 'sub CPU_DISP_DONTSTEAL () {0x1;}' unless defined(&CPU_DISP_DONTSTEAL);
	eval 'sub CPU_DISP_HALTED () {0x2;}' unless defined(&CPU_DISP_HALTED);
    }
    if((defined(&_KERNEL) || defined(&_KMEMUSER))  && defined(&_MACHDEP)) {
	eval 'sub CPUSET_WORDS () { &BT_BITOUL( &NCPU);}' unless defined(&CPUSET_WORDS);
	eval 'sub CPUSET_NOTINSET () {(( &uint_t)-1);}' unless defined(&CPUSET_NOTINSET);
	if((defined(&CPUSET_WORDS) ? &CPUSET_WORDS : undef) > 1) {
	    eval 'sub CPUSET_ALL {
	        my($set) = @_;
    		eval q( &cpuset_all(($set)));
	    }' unless defined(&CPUSET_ALL);
	    eval 'sub CPUSET_ALL_BUT {
	        my($set, $cpu) = @_;
    		eval q( &cpuset_all_but(($set), $cpu));
	    }' unless defined(&CPUSET_ALL_BUT);
	    eval 'sub CPUSET_ONLY {
	        my($set, $cpu) = @_;
    		eval q( &cpuset_only(($set), $cpu));
	    }' unless defined(&CPUSET_ONLY);
	    eval 'sub CPU_IN_SET {
	        my($set, $cpu) = @_;
    		eval q( &BT_TEST(($set). &cpub, $cpu));
	    }' unless defined(&CPU_IN_SET);
	    eval 'sub CPUSET_ADD {
	        my($set, $cpu) = @_;
    		eval q( &BT_SET(($set). &cpub, $cpu));
	    }' unless defined(&CPUSET_ADD);
	    eval 'sub CPUSET_DEL {
	        my($set, $cpu) = @_;
    		eval q( &BT_CLEAR(($set). &cpub, $cpu));
	    }' unless defined(&CPUSET_DEL);
	    eval 'sub CPUSET_ISNULL {
	        my($set) = @_;
    		eval q( &cpuset_isnull(($set)));
	    }' unless defined(&CPUSET_ISNULL);
	    eval 'sub CPUSET_ISEQUAL {
	        my($set1, $set2) = @_;
    		eval q( &cpuset_cmp(($set1), ($set2)));
	    }' unless defined(&CPUSET_ISEQUAL);
	    eval 'sub CPUSET_FIND {
	        my($set, $cpu) = @_;
    		eval q({ $cpu =  &cpuset_find(($set)); });
	    }' unless defined(&CPUSET_FIND);
	    eval 'sub CPUSET_BOUNDS {
	        my($set, $smallest, $largest) = @_;
    		eval q({  &cpuset_bounds(($set), ($smallest), ($largest)); });
	    }' unless defined(&CPUSET_BOUNDS);
	    eval 'sub CPUSET_ATOMIC_DEL {
	        my($set, $cpu) = @_;
    		eval q( &BT_ATOMIC_CLEAR(($set). &cpub, ($cpu)));
	    }' unless defined(&CPUSET_ATOMIC_DEL);
	    eval 'sub CPUSET_ATOMIC_ADD {
	        my($set, $cpu) = @_;
    		eval q( &BT_ATOMIC_SET(($set). &cpub, ($cpu)));
	    }' unless defined(&CPUSET_ATOMIC_ADD);
	    eval 'sub CPUSET_ATOMIC_XADD {
	        my($set, $cpu, $result) = @_;
    		eval q( &BT_ATOMIC_SET_EXCL(($set). &cpub, $cpu, $result));
	    }' unless defined(&CPUSET_ATOMIC_XADD);
	    eval 'sub CPUSET_ATOMIC_XDEL {
	        my($set, $cpu, $result) = @_;
    		eval q( &BT_ATOMIC_CLEAR_EXCL(($set). &cpub, $cpu, $result));
	    }' unless defined(&CPUSET_ATOMIC_XDEL);
	    eval 'sub CPUSET_OR {
	        my($set1, $set2) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set1). $cpub[ &_i] |= ($set2). $cpub[ &_i]; });
	    }' unless defined(&CPUSET_OR);
	    eval 'sub CPUSET_XOR {
	        my($set1, $set2) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set1). $cpub[ &_i] ^= ($set2). $cpub[ &_i]; });
	    }' unless defined(&CPUSET_XOR);
	    eval 'sub CPUSET_AND {
	        my($set1, $set2) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set1). $cpub[ &_i] &= ($set2). $cpub[ &_i]; });
	    }' unless defined(&CPUSET_AND);
	    eval 'sub CPUSET_ZERO {
	        my($set) = @_;
    		eval q({ \'int\'  &_i;  &for ( &_i = 0;  &_i <  &CPUSET_WORDS;  &_i++) ($set). $cpub[ &_i] = 0; });
	    }' unless defined(&CPUSET_ZERO);
	}
 elsif((defined(&CPUSET_WORDS) ? &CPUSET_WORDS : undef) == 1) {
	    eval 'sub CPUSET {
	        my($cpu) = @_;
    		eval q((1 << ($cpu)));
	    }' unless defined(&CPUSET);
	    eval 'sub CPUSET_ALL {
	        my($set) = @_;
    		eval q((( &void)(($set) = ~0)));
	    }' unless defined(&CPUSET_ALL);
	    eval 'sub CPUSET_ALL_BUT {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) = ~ &CPUSET($cpu))));
	    }' unless defined(&CPUSET_ALL_BUT);
	    eval 'sub CPUSET_ONLY {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) =  &CPUSET($cpu))));
	    }' unless defined(&CPUSET_ONLY);
	    eval 'sub CPU_IN_SET {
	        my($set, $cpu) = @_;
    		eval q((($set) &  &CPUSET($cpu)));
	    }' unless defined(&CPU_IN_SET);
	    eval 'sub CPUSET_ADD {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) |=  &CPUSET($cpu))));
	    }' unless defined(&CPUSET_ADD);
	    eval 'sub CPUSET_DEL {
	        my($set, $cpu) = @_;
    		eval q((( &void)(($set) &= ~ &CPUSET($cpu))));
	    }' unless defined(&CPUSET_DEL);
	    eval 'sub CPUSET_ISNULL {
	        my($set) = @_;
    		eval q((($set) == 0));
	    }' unless defined(&CPUSET_ISNULL);
	    eval 'sub CPUSET_ISEQUAL {
	        my($set1, $set2) = @_;
    		eval q((($set1) == ($set2)));
	    }' unless defined(&CPUSET_ISEQUAL);
	    eval 'sub CPUSET_OR {
	        my($set1, $set2) = @_;
    		eval q((( &void)(($set1) |= ($set2))));
	    }' unless defined(&CPUSET_OR);
	    eval 'sub CPUSET_XOR {
	        my($set1, $set2) = @_;
    		eval q((( &void)(($set1) ^= ($set2))));
	    }' unless defined(&CPUSET_XOR);
	    eval 'sub CPUSET_AND {
	        my($set1, $set2) = @_;
    		eval q((( &void)(($set1) &= ($set2))));
	    }' unless defined(&CPUSET_AND);
	    eval 'sub CPUSET_ZERO {
	        my($set) = @_;
    		eval q((( &void)(($set) = 0)));
	    }' unless defined(&CPUSET_ZERO);
	    eval 'sub CPUSET_FIND {
	        my($set, $cpu) = @_;
    		eval q({ $cpu = ( &uint_t)( &lowbit($set) - 1); });
	    }' unless defined(&CPUSET_FIND);
	    eval 'sub CPUSET_BOUNDS {
	        my($set, $smallest, $largest) = @_;
    		eval q({ $smallest = ( &uint_t)( &lowbit($set) - 1); $largest = ( &uint_t)( &highbit($set) - 1); });
	    }' unless defined(&CPUSET_BOUNDS);
	    eval 'sub CPUSET_ATOMIC_DEL {
	        my($set, $cpu) = @_;
    		eval q( &atomic_and_ulong(($set), ~ &CPUSET($cpu)));
	    }' unless defined(&CPUSET_ATOMIC_DEL);
	    eval 'sub CPUSET_ATOMIC_ADD {
	        my($set, $cpu) = @_;
    		eval q( &atomic_or_ulong(($set),  &CPUSET($cpu)));
	    }' unless defined(&CPUSET_ATOMIC_ADD);
	    eval 'sub CPUSET_ATOMIC_XADD {
	        my($set, $cpu, $result) = @_;
    		eval q({ $result =  &atomic_set_long_excl(($set), ($cpu)); });
	    }' unless defined(&CPUSET_ATOMIC_XADD);
	    eval 'sub CPUSET_ATOMIC_XDEL {
	        my($set, $cpu, $result) = @_;
    		eval q({ $result =  &atomic_clear_long_excl(($set), ($cpu)); });
	    }' unless defined(&CPUSET_ATOMIC_XDEL);
	} else {
	    die("NCPU\ is\ undefined\ or\ invalid");
	}
    }
    eval 'sub CPU_CPR_OFFLINE () {0x;}' unless defined(&CPU_CPR_OFFLINE);
    eval 'sub CPU_CPR_ONLINE () {0x1;}' unless defined(&CPU_CPR_ONLINE);
    eval 'sub CPU_CPR_IS_OFFLINE {
        my($cpu) = @_;
	    eval q(((($cpu)-> &cpu_cpr_flags &  &CPU_CPR_ONLINE) == 0));
    }' unless defined(&CPU_CPR_IS_OFFLINE);
    eval 'sub CPU_CPR_IS_ONLINE {
        my($cpu) = @_;
	    eval q((($cpu)-> &cpu_cpr_flags &  &CPU_CPR_ONLINE));
    }' unless defined(&CPU_CPR_IS_ONLINE);
    eval 'sub CPU_SET_CPR_FLAGS {
        my($cpu, $flag) = @_;
	    eval q((($cpu)-> &cpu_cpr_flags |= $flag));
    }' unless defined(&CPU_SET_CPR_FLAGS);
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	if(defined(&__i386) || defined(&__amd64)) {
	    eval 'sub CPU () {( &curcpup());}' unless defined(&CPU);
	} else {
	    eval 'sub CPU () {( ($curthread->{t_cpu}));}' unless defined(&CPU);
	}
	eval 'sub CPU_CURRENT () {-3;}' unless defined(&CPU_CURRENT);
	eval 'sub CPU_STATS_ENTER_K () {
	    eval q( &kpreempt_disable());
	}' unless defined(&CPU_STATS_ENTER_K);
	eval 'sub CPU_STATS_EXIT_K () {
	    eval q( &kpreempt_enable());
	}' unless defined(&CPU_STATS_EXIT_K);
	eval 'sub CPU_STATS_ADD_K {
	    my($class, $stat, $amount) = @_;
    	    eval q({  &kpreempt_disable();  &CPU_STATS_ADDQ( &CPU, $class, $stat, $amount);  &kpreempt_enable(); });
	}' unless defined(&CPU_STATS_ADD_K);
	eval 'sub CPU_STATS_ADDQ {
	    my($cp, $class, $stat, $amount) = @_;
    	    eval q({  &extern  &void  &__dtrace_probe___cpu_$class &info_$stat( &uint_t,  &uint64_t *,  &cpu_t *);  &uint64_t * &stataddr = (($cp)-> ($cpu_stats->{class}->{stat}));  &__dtrace_probe___cpu_$class &info_$stat(($amount),  &stataddr, $cp); *( &stataddr) += ($amount); });
	}' unless defined(&CPU_STATS_ADDQ);
	eval 'sub CPU_STATS {
	    my($cp, $stat) = @_;
    	    eval q((($cp)-> ($cpu_stats->{stat})));
	}' unless defined(&CPU_STATS);
	eval 'sub CPU_NEW_GENERATION {
	    my($cp) = @_;
    	    eval q((($cp)-> &cpu_generation++));
	}' unless defined(&CPU_NEW_GENERATION);
    }
    if(defined(&_KERNEL)  && defined(&__STDC__) ) {
	eval 'sub PAUSE_IDLE () {0;}' unless defined(&PAUSE_IDLE);
	eval 'sub PAUSE_READY () {1;}' unless defined(&PAUSE_READY);
	eval 'sub PAUSE_WAIT () {2;}' unless defined(&PAUSE_WAIT);
	eval 'sub PAUSE_DIE () {3;}' unless defined(&PAUSE_DIE);
	eval 'sub PAUSE_DEAD () {4;}' unless defined(&PAUSE_DEAD);
	eval("sub CPU_INIT () { 0; }") unless defined(&CPU_INIT);
	eval("sub CPU_CONFIG () { 1; }") unless defined(&CPU_CONFIG);
	eval("sub CPU_UNCONFIG () { 2; }") unless defined(&CPU_UNCONFIG);
	eval("sub CPU_ON () { 3; }") unless defined(&CPU_ON);
	eval("sub CPU_OFF () { 4; }") unless defined(&CPU_OFF);
	eval("sub CPU_CPUPART_IN () { 5; }") unless defined(&CPU_CPUPART_IN);
	eval("sub CPU_CPUPART_OUT () { 6; }") unless defined(&CPU_CPUPART_OUT);
	eval("sub CPU_SETUP () { 7; }") unless defined(&CPU_SETUP);
	eval("sub CPU_INTR_ON () { 8; }") unless defined(&CPU_INTR_ON);
	eval 'sub CPU_IDSTRLEN () {100;}' unless defined(&CPU_IDSTRLEN);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
