require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DEBUG_H)) {
    eval 'sub _SYS_DEBUG_H () {1;}' unless defined(&_SYS_DEBUG_H);
    require 'sys/isa_defs.ph';
    require 'sys/types.ph';
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub VERIFY {
        my($EX) = @_;
	    eval q((( &void)(($EX) ||  &assfail($EX,  &__FILE__,  &__LINE__))));
    }' unless defined(&VERIFY);
    if((defined(&DEBUG) ? &DEBUG : undef)) {
	eval 'sub ASSERT {
	    my($EX) = @_;
    	    eval q((( &void)(($EX) ||  &assfail($EX,  &__FILE__,  &__LINE__))));
	}' unless defined(&ASSERT);
    } else {
	eval 'sub ASSERT {
	    my($x) = @_;
    	    eval q((( &void)0));
	}' unless defined(&ASSERT);
    }
    if(defined(&_LP64)) {
	eval 'sub ASSERT64 {
	    my($x) = @_;
    	    eval q( &ASSERT($x));
	}' unless defined(&ASSERT64);
	eval 'sub ASSERT32 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&ASSERT32);
    } else {
	eval 'sub ASSERT64 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&ASSERT64);
	eval 'sub ASSERT32 {
	    my($x) = @_;
    	    eval q( &ASSERT($x));
	}' unless defined(&ASSERT32);
    }
    if((defined(&DEBUG) ? &DEBUG : undef)) {
	eval 'sub IMPLY {
	    my($A, $B) = @_;
    	    eval q((( &void)(((!($A)) || ($B)) ||  &assfail(\\"(\\" $A \\") implies (\\" $B \\")\\",  &__FILE__,  &__LINE__))));
	}' unless defined(&IMPLY);
	eval 'sub EQUIV {
	    my($A, $B) = @_;
    	    eval q((( &void)((!!($A) == !!($B)) ||  &assfail(\\"(\\" $A \\") is equivalent to (\\" $B \\")\\",  &__FILE__,  &__LINE__))));
	}' unless defined(&EQUIV);
    } else {
	eval 'sub IMPLY {
	    my($A, $B) = @_;
    	    eval q((( &void)0));
	}' unless defined(&IMPLY);
	eval 'sub EQUIV {
	    my($A, $B) = @_;
    	    eval q((( &void)0));
	}' unless defined(&EQUIV);
    }
    eval 'sub VERIFY3_IMPL {
        my($LEFT, $OP, $RIGHT, $TYPE) = @_;
	    eval q( &do {  &const $TYPE  &__left = ($TYPE)($LEFT);  &const $TYPE  &__right = ($TYPE)($RIGHT);  &if (!( &__left $OP  &__right))  &assfail3($LEFT \\" \\" $OP \\" \\" $RIGHT, ( &uintmax_t) &__left, $OP, ( &uintmax_t) &__right,  &__FILE__,  &__LINE__);  &_NOTE( &CONSTCOND) }  &while (0));
    }' unless defined(&VERIFY3_IMPL);
    eval 'sub VERIFY3S {
        my($x, $y, $z) = @_;
	    eval q( &VERIFY3_IMPL($x, $y, $z,  &int64_t));
    }' unless defined(&VERIFY3S);
    eval 'sub VERIFY3U {
        my($x, $y, $z) = @_;
	    eval q( &VERIFY3_IMPL($x, $y, $z,  &uint64_t));
    }' unless defined(&VERIFY3U);
    eval 'sub VERIFY3P {
        my($x, $y, $z) = @_;
	    eval q( &VERIFY3_IMPL($x, $y, $z,  &uintptr_t));
    }' unless defined(&VERIFY3P);
    eval 'sub VERIFY0 {
        my($x) = @_;
	    eval q( &VERIFY3_IMPL($x, ==, 0,  &uintmax_t));
    }' unless defined(&VERIFY0);
    if((defined(&DEBUG) ? &DEBUG : undef)) {
	eval 'sub ASSERT3S {
	    my($x, $y, $z) = @_;
    	    eval q( &VERIFY3_IMPL($x, $y, $z,  &int64_t));
	}' unless defined(&ASSERT3S);
	eval 'sub ASSERT3U {
	    my($x, $y, $z) = @_;
    	    eval q( &VERIFY3_IMPL($x, $y, $z,  &uint64_t));
	}' unless defined(&ASSERT3U);
	eval 'sub ASSERT3P {
	    my($x, $y, $z) = @_;
    	    eval q( &VERIFY3_IMPL($x, $y, $z,  &uintptr_t));
	}' unless defined(&ASSERT3P);
	eval 'sub ASSERT0 {
	    my($x) = @_;
    	    eval q( &VERIFY3_IMPL($x, ==, 0,  &uintmax_t));
	}' unless defined(&ASSERT0);
    } else {
	eval 'sub ASSERT3S {
	    my($x, $y, $z) = @_;
    	    eval q((( &void)0));
	}' unless defined(&ASSERT3S);
	eval 'sub ASSERT3U {
	    my($x, $y, $z) = @_;
    	    eval q((( &void)0));
	}' unless defined(&ASSERT3U);
	eval 'sub ASSERT3P {
	    my($x, $y, $z) = @_;
    	    eval q((( &void)0));
	}' unless defined(&ASSERT3P);
	eval 'sub ASSERT0 {
	    my($x) = @_;
    	    eval q((( &void)0));
	}' unless defined(&ASSERT0);
    }
    eval 'sub CTASSERT {
        my($x) = @_;
	    eval q( &_CTASSERT($x,  &__LINE__));
    }' unless defined(&CTASSERT);
    eval 'sub _CTASSERT {
        my($x, $y) = @_;
	    eval q( &__CTASSERT($x, $y));
    }' unless defined(&_CTASSERT);
    eval 'sub __CTASSERT {
        my($x, $y) = @_;
	    eval q( &typedef \'char\'  &__compile_time_assertion__  $y [($x) ? 1: -1]);
    }' unless defined(&__CTASSERT);
    if(defined(&_KERNEL)) {
    }
    if(defined(&DEBUG)  && !defined(&__sun)) {
	eval 'sub STATIC () {1;}' unless defined(&STATIC);
    } else {
	eval 'sub STATIC () { &static;}' unless defined(&STATIC);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
