require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_FCNTL_H)) {
    eval 'sub _SYS_FCNTL_H () {1;}' unless defined(&_SYS_FCNTL_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub O_RDONLY () {0;}' unless defined(&O_RDONLY);
    eval 'sub O_WRONLY () {1;}' unless defined(&O_WRONLY);
    eval 'sub O_RDWR () {2;}' unless defined(&O_RDWR);
    eval 'sub O_SEARCH () {0x200000;}' unless defined(&O_SEARCH);
    eval 'sub O_EXEC () {0x400000;}' unless defined(&O_EXEC);
    if(defined(&__EXTENSIONS__) || !defined(&_POSIX_C_SOURCE)) {
	eval 'sub O_NDELAY () {0x4;}' unless defined(&O_NDELAY);
    }
    eval 'sub O_APPEND () {0x8;}' unless defined(&O_APPEND);
    if(defined(&__EXTENSIONS__) || !defined(&_POSIX_C_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&_XOPEN_SOURCE)) {
	eval 'sub O_SYNC () {0x10;}' unless defined(&O_SYNC);
	eval 'sub O_DSYNC () {0x40;}' unless defined(&O_DSYNC);
	eval 'sub O_RSYNC () {0x8000;}' unless defined(&O_RSYNC);
    }
    eval 'sub O_NONBLOCK () {0x80;}' unless defined(&O_NONBLOCK);
    if(defined(&_LARGEFILE_SOURCE)) {
	eval 'sub O_LARGEFILE () {0x2000;}' unless defined(&O_LARGEFILE);
    }
    eval 'sub O_CREAT () {0x100;}' unless defined(&O_CREAT);
    eval 'sub O_TRUNC () {0x200;}' unless defined(&O_TRUNC);
    eval 'sub O_EXCL () {0x400;}' unless defined(&O_EXCL);
    eval 'sub O_NOCTTY () {0x800;}' unless defined(&O_NOCTTY);
    eval 'sub O_XATTR () {0x4000;}' unless defined(&O_XATTR);
    eval 'sub O_NOFOLLOW () {0x20000;}' unless defined(&O_NOFOLLOW);
    eval 'sub O_NOLINKS () {0x40000;}' unless defined(&O_NOLINKS);
    eval 'sub O_CLOEXEC () {0x800000;}' unless defined(&O_CLOEXEC);
    eval 'sub F_DUPFD () {0;}' unless defined(&F_DUPFD);
    eval 'sub F_GETFD () {1;}' unless defined(&F_GETFD);
    eval 'sub F_SETFD () {2;}' unless defined(&F_SETFD);
    eval 'sub F_GETFL () {3;}' unless defined(&F_GETFL);
    eval 'sub F_GETXFL () {45;}' unless defined(&F_GETXFL);
    eval 'sub F_SETFL () {4;}' unless defined(&F_SETFL);
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	eval 'sub F_O_GETLK () {5;}' unless defined(&F_O_GETLK);
	eval 'sub SYSIDMASK () {0xffff;}' unless defined(&SYSIDMASK);
	eval 'sub GETSYSID {
	    my($id) = @_;
    	    eval q(($id &  &SYSIDMASK));
	}' unless defined(&GETSYSID);
	eval 'sub NODEIDMASK () {0xffff0000;}' unless defined(&NODEIDMASK);
	eval 'sub BITS_IN_SYSID () {16;}' unless defined(&BITS_IN_SYSID);
	eval 'sub GETNLMID {
	    my($sysid) = @_;
    	    eval q((((( &uint_t)($sysid) &  &NODEIDMASK) >>  &BITS_IN_SYSID)));
	}' unless defined(&GETNLMID);
	eval 'sub GETPXFSID {
	    my($sysid) = @_;
    	    eval q((((( &uint_t)($sysid) &  &NODEIDMASK) >>  &BITS_IN_SYSID)));
	}' unless defined(&GETPXFSID);
    }
    eval 'sub F_CHKFL () {8;}' unless defined(&F_CHKFL);
    eval 'sub F_DUP2FD () {9;}' unless defined(&F_DUP2FD);
    eval 'sub F_DUP2FD_CLOEXEC () {36;}' unless defined(&F_DUP2FD_CLOEXEC);
    eval 'sub F_DUPFD_CLOEXEC () {37;}' unless defined(&F_DUPFD_CLOEXEC);
    eval 'sub F_ISSTREAM () {13;}' unless defined(&F_ISSTREAM);
    eval 'sub F_PRIV () {15;}' unless defined(&F_PRIV);
    eval 'sub F_NPRIV () {16;}' unless defined(&F_NPRIV);
    eval 'sub F_QUOTACTL () {17;}' unless defined(&F_QUOTACTL);
    eval 'sub F_BLOCKS () {18;}' unless defined(&F_BLOCKS);
    eval 'sub F_BLKSIZE () {19;}' unless defined(&F_BLKSIZE);
    eval 'sub F_GETOWN () {23;}' unless defined(&F_GETOWN);
    eval 'sub F_SETOWN () {24;}' unless defined(&F_SETOWN);
    eval 'sub F_REVOKE () {25;}' unless defined(&F_REVOKE);
    eval 'sub F_HASREMOTELOCKS () {26;}' unless defined(&F_HASREMOTELOCKS);
    if(defined(&_LP64) || (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 32) {
	eval 'sub F_SETLK () {6;}' unless defined(&F_SETLK);
	eval 'sub F_SETLKW () {7;}' unless defined(&F_SETLKW);
	eval 'sub F_ALLOCSP () {10;}' unless defined(&F_ALLOCSP);
	eval 'sub F_FREESP () {11;}' unless defined(&F_FREESP);
	eval 'sub F_GETLK () {14;}' unless defined(&F_GETLK);
	eval 'sub F_SETLK_NBMAND () {42;}' unless defined(&F_SETLK_NBMAND);
    } else {
	eval 'sub F_SETLK () {34;}' unless defined(&F_SETLK);
	eval 'sub F_SETLKW () {35;}' unless defined(&F_SETLKW);
	eval 'sub F_ALLOCSP () {28;}' unless defined(&F_ALLOCSP);
	eval 'sub F_FREESP () {27;}' unless defined(&F_FREESP);
	eval 'sub F_GETLK () {33;}' unless defined(&F_GETLK);
	eval 'sub F_SETLK_NBMAND () {44;}' unless defined(&F_SETLK_NBMAND);
    }
    if(defined(&_LARGEFILE64_SOURCE)) {
	if(!defined(&_LP64) || defined(&_KERNEL)) {
	    eval 'sub F_SETLK64 () {34;}' unless defined(&F_SETLK64);
	    eval 'sub F_SETLKW64 () {35;}' unless defined(&F_SETLKW64);
	    eval 'sub F_ALLOCSP64 () {28;}' unless defined(&F_ALLOCSP64);
	    eval 'sub F_FREESP64 () {27;}' unless defined(&F_FREESP64);
	    eval 'sub F_GETLK64 () {33;}' unless defined(&F_GETLK64);
	    eval 'sub F_SETLK64_NBMAND () {44;}' unless defined(&F_SETLK64_NBMAND);
	} else {
	    eval 'sub F_SETLK64 () {6;}' unless defined(&F_SETLK64);
	    eval 'sub F_SETLKW64 () {7;}' unless defined(&F_SETLKW64);
	    eval 'sub F_ALLOCSP64 () {10;}' unless defined(&F_ALLOCSP64);
	    eval 'sub F_FREESP64 () {11;}' unless defined(&F_FREESP64);
	    eval 'sub F_GETLK64 () {14;}' unless defined(&F_GETLK64);
	    eval 'sub F_SETLK64_NBMAND () {42;}' unless defined(&F_SETLK64_NBMAND);
	}
    }
    eval 'sub F_SHARE () {40;}' unless defined(&F_SHARE);
    eval 'sub F_UNSHARE () {41;}' unless defined(&F_UNSHARE);
    eval 'sub F_SHARE_NBMAND () {43;}' unless defined(&F_SHARE_NBMAND);
    eval 'sub F_BADFD () {46;}' unless defined(&F_BADFD);
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_LARGEFILE64_SOURCE)) {
	if(defined(&_SYSCALL32)) {
	    if((defined(&_LONG_LONG_ALIGNMENT) ? &_LONG_LONG_ALIGNMENT : undef) == 8 && (defined(&_LONG_LONG_ALIGNMENT_32) ? &_LONG_LONG_ALIGNMENT_32 : undef) == 4) {
	    }
	    if((defined(&_LONG_LONG_ALIGNMENT) ? &_LONG_LONG_ALIGNMENT : undef) == 8 && (defined(&_LONG_LONG_ALIGNMENT_32) ? &_LONG_LONG_ALIGNMENT_32 : undef) == 4) {
	    }
	}
    }
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
    }
    eval 'sub F_RDLCK () {01;}' unless defined(&F_RDLCK);
    eval 'sub F_WRLCK () {02;}' unless defined(&F_WRLCK);
    eval 'sub F_UNLCK () {03;}' unless defined(&F_UNLCK);
    eval 'sub F_UNLKSYS () {04;}' unless defined(&F_UNLKSYS);
    eval 'sub O_ACCMODE () {( &O_SEARCH |  &O_EXEC | 0x3);}' unless defined(&O_ACCMODE);
    eval 'sub FD_CLOEXEC () {1;}' unless defined(&FD_CLOEXEC);
    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX)) {
	eval 'sub DIRECTIO_OFF () {(0);}' unless defined(&DIRECTIO_OFF);
	eval 'sub DIRECTIO_ON () {(1);}' unless defined(&DIRECTIO_ON);
	eval 'sub F_RDACC () {0x1;}' unless defined(&F_RDACC);
	eval 'sub F_WRACC () {0x2;}' unless defined(&F_WRACC);
	eval 'sub F_RWACC () {0x3;}' unless defined(&F_RWACC);
	eval 'sub F_RMACC () {0x4;}' unless defined(&F_RMACC);
	eval 'sub F_MDACC () {0x20;}' unless defined(&F_MDACC);
	eval 'sub F_NODNY () {0x;}' unless defined(&F_NODNY);
	eval 'sub F_RDDNY () {0x1;}' unless defined(&F_RDDNY);
	eval 'sub F_WRDNY () {0x2;}' unless defined(&F_WRDNY);
	eval 'sub F_RWDNY () {0x3;}' unless defined(&F_RWDNY);
	eval 'sub F_RMDNY () {0x4;}' unless defined(&F_RMDNY);
	eval 'sub F_COMPAT () {0x8;}' unless defined(&F_COMPAT);
	eval 'sub F_MANDDNY () {0x10;}' unless defined(&F_MANDDNY);
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE) || defined(&__EXTENSIONS__)) {
	eval 'sub AT_FDCWD () {0xffd19553;}' unless defined(&AT_FDCWD);
	eval 'sub AT_SYMLINK_NOFOLLOW () {0x1000;}' unless defined(&AT_SYMLINK_NOFOLLOW);
	eval 'sub AT_SYMLINK_FOLLOW () {0x2000;}' unless defined(&AT_SYMLINK_FOLLOW);
	eval 'sub AT_REMOVEDIR () {0x1;}' unless defined(&AT_REMOVEDIR);
	eval 'sub _AT_TRIGGER () {0x2;}' unless defined(&_AT_TRIGGER);
	eval 'sub AT_EACCESS () {0x4;}' unless defined(&AT_EACCESS);
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	eval 'sub POSIX_FADV_NORMAL () {0;}' unless defined(&POSIX_FADV_NORMAL);
	eval 'sub POSIX_FADV_RANDOM () {1;}' unless defined(&POSIX_FADV_RANDOM);
	eval 'sub POSIX_FADV_SEQUENTIAL () {2;}' unless defined(&POSIX_FADV_SEQUENTIAL);
	eval 'sub POSIX_FADV_WILLNEED () {3;}' unless defined(&POSIX_FADV_WILLNEED);
	eval 'sub POSIX_FADV_DONTNEED () {4;}' unless defined(&POSIX_FADV_DONTNEED);
	eval 'sub POSIX_FADV_NOREUSE () {5;}' unless defined(&POSIX_FADV_NOREUSE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
