require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_INT_LIMITS_H)) {
    eval 'sub _SYS_INT_LIMITS_H () {1;}' unless defined(&_SYS_INT_LIMITS_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	eval 'sub INT8_MAX () {(127);}' unless defined(&INT8_MAX);
    }
    eval 'sub INT16_MAX () {(32767);}' unless defined(&INT16_MAX);
    eval 'sub INT32_MAX () {(2147483647);}' unless defined(&INT32_MAX);
    if(defined(&_LP64)) {
	eval 'sub INT64_MAX () {(9223372036854775807);}' unless defined(&INT64_MAX);
    }
 elsif(defined(&_LONGLONG_TYPE)) {
	eval 'sub INT64_MAX () {(9223372036854775807);}' unless defined(&INT64_MAX);
    }
    eval 'sub UINT8_MAX () {(255);}' unless defined(&UINT8_MAX);
    eval 'sub UINT16_MAX () {(65535);}' unless defined(&UINT16_MAX);
    eval 'sub UINT32_MAX () {(4294967295);}' unless defined(&UINT32_MAX);
    if(defined(&_LP64)) {
	eval 'sub UINT64_MAX () {(18446744073709551615);}' unless defined(&UINT64_MAX);
    }
 elsif(defined(&_LONGLONG_TYPE)) {
	eval 'sub UINT64_MAX () {(18446744073709551615);}' unless defined(&UINT64_MAX);
    }
    if(defined(&INT64_MAX)) {
	eval 'sub INTMAX_MAX () { &INT64_MAX;}' unless defined(&INTMAX_MAX);
    } else {
	eval 'sub INTMAX_MAX () { &INT32_MAX;}' unless defined(&INTMAX_MAX);
    }
    if(defined(&UINT64_MAX)) {
	eval 'sub UINTMAX_MAX () { &UINT64_MAX;}' unless defined(&UINTMAX_MAX);
    } else {
	eval 'sub UINTMAX_MAX () { &UINT32_MAX;}' unless defined(&UINTMAX_MAX);
    }
    if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	eval 'sub INT_LEAST8_MAX () { &INT8_MAX;}' unless defined(&INT_LEAST8_MAX);
    }
    eval 'sub INT_LEAST16_MAX () { &INT16_MAX;}' unless defined(&INT_LEAST16_MAX);
    eval 'sub INT_LEAST32_MAX () { &INT32_MAX;}' unless defined(&INT_LEAST32_MAX);
    if(defined(&INT64_MAX)) {
	eval 'sub INT_LEAST64_MAX () { &INT64_MAX;}' unless defined(&INT_LEAST64_MAX);
    }
    eval 'sub UINT_LEAST8_MAX () { &UINT8_MAX;}' unless defined(&UINT_LEAST8_MAX);
    eval 'sub UINT_LEAST16_MAX () { &UINT16_MAX;}' unless defined(&UINT_LEAST16_MAX);
    eval 'sub UINT_LEAST32_MAX () { &UINT32_MAX;}' unless defined(&UINT_LEAST32_MAX);
    if(defined(&UINT64_MAX)) {
	eval 'sub UINT_LEAST64_MAX () { &UINT64_MAX;}' unless defined(&UINT_LEAST64_MAX);
    }
    if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	eval 'sub INT_FAST8_MAX () { &INT8_MAX;}' unless defined(&INT_FAST8_MAX);
    }
    eval 'sub INT_FAST16_MAX () { &INT32_MAX;}' unless defined(&INT_FAST16_MAX);
    eval 'sub INT_FAST32_MAX () { &INT32_MAX;}' unless defined(&INT_FAST32_MAX);
    if(defined(&INT64_MAX)) {
	eval 'sub INT_FAST64_MAX () { &INT64_MAX;}' unless defined(&INT_FAST64_MAX);
    }
    eval 'sub UINT_FAST8_MAX () { &UINT8_MAX;}' unless defined(&UINT_FAST8_MAX);
    eval 'sub UINT_FAST16_MAX () { &UINT32_MAX;}' unless defined(&UINT_FAST16_MAX);
    eval 'sub UINT_FAST32_MAX () { &UINT32_MAX;}' unless defined(&UINT_FAST32_MAX);
    if(defined(&UINT64_MAX)) {
	eval 'sub UINT_FAST64_MAX () { &UINT64_MAX;}' unless defined(&UINT_FAST64_MAX);
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
	eval 'sub INTPTR_MAX () { &INT64_MAX;}' unless defined(&INTPTR_MAX);
	eval 'sub UINTPTR_MAX () { &UINT64_MAX;}' unless defined(&UINTPTR_MAX);
    } else {
	eval 'sub INTPTR_MAX () { &INT32_MAX;}' unless defined(&INTPTR_MAX);
	eval 'sub UINTPTR_MAX () { &UINT32_MAX;}' unless defined(&UINTPTR_MAX);
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
	eval 'sub PTRDIFF_MAX () {9223372036854775807;}' unless defined(&PTRDIFF_MAX);
    } else {
	eval 'sub PTRDIFF_MAX () {2147483647;}' unless defined(&PTRDIFF_MAX);
    }
    if(defined(&_LP64)) {
	eval 'sub SIZE_MAX () {18446744073709551615;}' unless defined(&SIZE_MAX);
    } else {
	eval 'sub SIZE_MAX () {4294967295;}' unless defined(&SIZE_MAX);
    }
    unless(defined(&SIG_ATOMIC_MAX)) {
	eval 'sub SIG_ATOMIC_MAX () {2147483647;}' unless defined(&SIG_ATOMIC_MAX);
    }
    unless(defined(&WCHAR_MAX)) {
	eval 'sub WCHAR_MAX () {2147483647;}' unless defined(&WCHAR_MAX);
    }
    unless(defined(&WINT_MAX)) {
	eval 'sub WINT_MAX () {2147483647;}' unless defined(&WINT_MAX);
    }
    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_XPG6)) {
	if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	    eval 'sub INT8_MIN () {(-128);}' unless defined(&INT8_MIN);
	}
	eval 'sub INT16_MIN () {(-32767-1);}' unless defined(&INT16_MIN);
	eval 'sub INT32_MIN () {(-2147483647-1);}' unless defined(&INT32_MIN);
	if(defined(&_LP64)) {
	    eval 'sub INT64_MIN () {(-9223372036854775807-1);}' unless defined(&INT64_MIN);
	}
 elsif(defined(&_LONGLONG_TYPE)) {
	    eval 'sub INT64_MIN () {(-9223372036854775807-1);}' unless defined(&INT64_MIN);
	}
	if(defined(&INT64_MIN)) {
	    eval 'sub INTMAX_MIN () { &INT64_MIN;}' unless defined(&INTMAX_MIN);
	} else {
	    eval 'sub INTMAX_MIN () { &INT32_MIN;}' unless defined(&INTMAX_MIN);
	}
	if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	    eval 'sub INT_LEAST8_MIN () { &INT8_MIN;}' unless defined(&INT_LEAST8_MIN);
	}
	eval 'sub INT_LEAST16_MIN () { &INT16_MIN;}' unless defined(&INT_LEAST16_MIN);
	eval 'sub INT_LEAST32_MIN () { &INT32_MIN;}' unless defined(&INT_LEAST32_MIN);
	if(defined(&INT64_MIN)) {
	    eval 'sub INT_LEAST64_MIN () { &INT64_MIN;}' unless defined(&INT_LEAST64_MIN);
	}
	if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	    eval 'sub INT_FAST8_MIN () { &INT8_MIN;}' unless defined(&INT_FAST8_MIN);
	}
	eval 'sub INT_FAST16_MIN () { &INT32_MIN;}' unless defined(&INT_FAST16_MIN);
	eval 'sub INT_FAST32_MIN () { &INT32_MIN;}' unless defined(&INT_FAST32_MIN);
	if(defined(&INT64_MIN)) {
	    eval 'sub INT_FAST64_MIN () { &INT64_MIN;}' unless defined(&INT_FAST64_MIN);
	}
	if(defined(&_LP64) || defined(&_I32LPx)) {
	    eval 'sub INTPTR_MIN () { &INT64_MIN;}' unless defined(&INTPTR_MIN);
	} else {
	    eval 'sub INTPTR_MIN () { &INT32_MIN;}' unless defined(&INTPTR_MIN);
	}
	if(defined(&_LP64) || defined(&_I32LPx)) {
	    eval 'sub PTRDIFF_MIN () {(-9223372036854775807-1);}' unless defined(&PTRDIFF_MIN);
	} else {
	    eval 'sub PTRDIFF_MIN () {(-2147483647-1);}' unless defined(&PTRDIFF_MIN);
	}
	unless(defined(&SIG_ATOMIC_MIN)) {
	    eval 'sub SIG_ATOMIC_MIN () {(-2147483647-1);}' unless defined(&SIG_ATOMIC_MIN);
	}
	unless(defined(&WCHAR_MIN)) {
	    eval 'sub WCHAR_MIN () {(-2147483647-1);}' unless defined(&WCHAR_MIN);
	}
	unless(defined(&WINT_MIN)) {
	    eval 'sub WINT_MIN () {(-2147483647-1);}' unless defined(&WINT_MIN);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
