require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_KSTAT_H)) {
    eval 'sub _SYS_KSTAT_H () {1;}' unless defined(&_SYS_KSTAT_H);
    require 'sys/types.ph';
    require 'sys/time.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub KSTAT_IOC_BASE () {(ord(\'K\') << 8);}' unless defined(&KSTAT_IOC_BASE);
    eval 'sub KSTAT_IOC_CHAIN_ID () { &KSTAT_IOC_BASE | 0x1;}' unless defined(&KSTAT_IOC_CHAIN_ID);
    eval 'sub KSTAT_IOC_READ () { &KSTAT_IOC_BASE | 0x2;}' unless defined(&KSTAT_IOC_READ);
    eval 'sub KSTAT_IOC_WRITE () { &KSTAT_IOC_BASE | 0x3;}' unless defined(&KSTAT_IOC_WRITE);
    eval 'sub KSTAT_STRLEN () {31;}' unless defined(&KSTAT_STRLEN);
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub KSTAT_ENTER {
	    my($k) = @_;
    	    eval q({  &kmutex_t * &lp = ($k)-> &ks_lock;  &if ( &lp)  &mutex_enter( &lp); });
	}' unless defined(&KSTAT_ENTER);
	eval 'sub KSTAT_EXIT {
	    my($k) = @_;
    	    eval q({  &kmutex_t * &lp = ($k)-> &ks_lock;  &if ( &lp)  &mutex_exit( &lp); });
	}' unless defined(&KSTAT_EXIT);
	eval 'sub KSTAT_UPDATE {
	    my($k, $rw) = @_;
    	    eval q((*($k)-> &ks_update)(($k), ($rw)));
	}' unless defined(&KSTAT_UPDATE);
	eval 'sub KSTAT_SNAPSHOT {
	    my($k, $buf, $rw) = @_;
    	    eval q((*($k)-> &ks_snapshot)(($k), ($buf), ($rw)));
	}' unless defined(&KSTAT_SNAPSHOT);
    }
    eval 'sub KSTAT_TYPE_RAW () {0;}' unless defined(&KSTAT_TYPE_RAW);
    eval 'sub KSTAT_TYPE_NAMED () {1;}' unless defined(&KSTAT_TYPE_NAMED);
    eval 'sub KSTAT_TYPE_INTR () {2;}' unless defined(&KSTAT_TYPE_INTR);
    eval 'sub KSTAT_TYPE_IO () {3;}' unless defined(&KSTAT_TYPE_IO);
    eval 'sub KSTAT_TYPE_TIMER () {4;}' unless defined(&KSTAT_TYPE_TIMER);
    eval 'sub KSTAT_NUM_TYPES () {5;}' unless defined(&KSTAT_NUM_TYPES);
    eval 'sub KSTAT_FLAG_VIRTUAL () {0x1;}' unless defined(&KSTAT_FLAG_VIRTUAL);
    eval 'sub KSTAT_FLAG_VAR_SIZE () {0x2;}' unless defined(&KSTAT_FLAG_VAR_SIZE);
    eval 'sub KSTAT_FLAG_WRITABLE () {0x4;}' unless defined(&KSTAT_FLAG_WRITABLE);
    eval 'sub KSTAT_FLAG_PERSISTENT () {0x8;}' unless defined(&KSTAT_FLAG_PERSISTENT);
    eval 'sub KSTAT_FLAG_DORMANT () {0x10;}' unless defined(&KSTAT_FLAG_DORMANT);
    eval 'sub KSTAT_FLAG_INVALID () {0x20;}' unless defined(&KSTAT_FLAG_INVALID);
    eval 'sub KSTAT_READ () {0;}' unless defined(&KSTAT_READ);
    eval 'sub KSTAT_WRITE () {1;}' unless defined(&KSTAT_WRITE);
    if(defined(&_KERNEL)  && defined(&_MULTI_DATAMODEL)) {
    }
    if(defined(&_INT64_TYPE)) {
    }
    eval 'sub KSTAT_DATA_CHAR () {0;}' unless defined(&KSTAT_DATA_CHAR);
    eval 'sub KSTAT_DATA_INT32 () {1;}' unless defined(&KSTAT_DATA_INT32);
    eval 'sub KSTAT_DATA_UINT32 () {2;}' unless defined(&KSTAT_DATA_UINT32);
    eval 'sub KSTAT_DATA_INT64 () {3;}' unless defined(&KSTAT_DATA_INT64);
    eval 'sub KSTAT_DATA_UINT64 () {4;}' unless defined(&KSTAT_DATA_UINT64);
    if(!defined(&_LP64)) {
	eval 'sub KSTAT_DATA_LONG () { &KSTAT_DATA_INT32;}' unless defined(&KSTAT_DATA_LONG);
	eval 'sub KSTAT_DATA_ULONG () { &KSTAT_DATA_UINT32;}' unless defined(&KSTAT_DATA_ULONG);
    } else {
	if(!defined(&_KERNEL)) {
	    eval 'sub KSTAT_DATA_LONG () { &KSTAT_DATA_INT64;}' unless defined(&KSTAT_DATA_LONG);
	    eval 'sub KSTAT_DATA_ULONG () { &KSTAT_DATA_UINT64;}' unless defined(&KSTAT_DATA_ULONG);
	} else {
	    eval 'sub KSTAT_DATA_LONG () {7;}' unless defined(&KSTAT_DATA_LONG);
	    eval 'sub KSTAT_DATA_ULONG () {8;}' unless defined(&KSTAT_DATA_ULONG);
	}
    }
    eval 'sub KSTAT_DATA_STRING () {9;}' unless defined(&KSTAT_DATA_STRING);
    eval 'sub KSTAT_DATA_LONGLONG () { &KSTAT_DATA_INT64;}' unless defined(&KSTAT_DATA_LONGLONG);
    eval 'sub KSTAT_DATA_ULONGLONG () { &KSTAT_DATA_UINT64;}' unless defined(&KSTAT_DATA_ULONGLONG);
    eval 'sub KSTAT_DATA_FLOAT () {5;}' unless defined(&KSTAT_DATA_FLOAT);
    eval 'sub KSTAT_DATA_DOUBLE () {6;}' unless defined(&KSTAT_DATA_DOUBLE);
    eval 'sub KSTAT_NAMED_PTR {
        my($kptr) = @_;
	    eval q((( &kstat_named_t *)($kptr)-> &ks_data));
    }' unless defined(&KSTAT_NAMED_PTR);
    eval 'sub KSTAT_NAMED_STR_PTR {
        my($knptr) = @_;
	    eval q((($knptr)-> ($value->{str}->{addr}->{ptr})));
    }' unless defined(&KSTAT_NAMED_STR_PTR);
    eval 'sub KSTAT_NAMED_STR_BUFLEN {
        my($knptr) = @_;
	    eval q((($knptr)-> ($value->{str}->{len})));
    }' unless defined(&KSTAT_NAMED_STR_BUFLEN);
    eval 'sub KSTAT_INTR_HARD () {0;}' unless defined(&KSTAT_INTR_HARD);
    eval 'sub KSTAT_INTR_SOFT () {1;}' unless defined(&KSTAT_INTR_SOFT);
    eval 'sub KSTAT_INTR_WATCHDOG () {2;}' unless defined(&KSTAT_INTR_WATCHDOG);
    eval 'sub KSTAT_INTR_SPURIOUS () {3;}' unless defined(&KSTAT_INTR_SPURIOUS);
    eval 'sub KSTAT_INTR_MULTSVC () {4;}' unless defined(&KSTAT_INTR_MULTSVC);
    eval 'sub KSTAT_NUM_INTRS () {5;}' unless defined(&KSTAT_NUM_INTRS);
    eval 'sub KSTAT_INTR_PTR {
        my($kptr) = @_;
	    eval q((( &kstat_intr_t *)($kptr)-> &ks_data));
    }' unless defined(&KSTAT_INTR_PTR);
    eval 'sub KSTAT_IO_PTR {
        my($kptr) = @_;
	    eval q((( &kstat_io_t *)($kptr)-> &ks_data));
    }' unless defined(&KSTAT_IO_PTR);
    eval 'sub KSTAT_TIMER_PTR {
        my($kptr) = @_;
	    eval q((( &kstat_timer_t *)($kptr)-> &ks_data));
    }' unless defined(&KSTAT_TIMER_PTR);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	require 'sys/t_lock.ph';
    }
    if(defined(&__cplusplus)) {
    }
}
1;
