require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MACHPARAM_H)) {
    eval 'sub _SYS_MACHPARAM_H () {1;}' unless defined(&_SYS_MACHPARAM_H);
    if(!defined(&_ASM)) {
	require 'sys/types.ph';
	if(defined(&__xpv)) {
	    require 'sys/xpv_impl.ph';
	}
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	eval 'sub ADDRESS_C {
	    my($c) = @_;
    	    eval q($c   &ul);
	}' unless defined(&ADDRESS_C);
    } else {
	eval 'sub ADDRESS_C {
	    my($c) = @_;
    	    eval q(($c));
	}' unless defined(&ADDRESS_C);
    }
    if(defined(&__amd64)) {
	eval 'sub NCPU () {256;}' unless defined(&NCPU);
	eval 'sub NCPU_LOG2 () {8;}' unless defined(&NCPU_LOG2);
    }
 elsif(defined(&__i386)) {
	eval 'sub NCPU () {32;}' unless defined(&NCPU);
	eval 'sub NCPU_LOG2 () {5;}' unless defined(&NCPU_LOG2);
    }
    eval 'sub NCPU_P2 () {(1<<  &NCPU_LOG2);}' unless defined(&NCPU_P2);
    eval 'sub MAXNODES () {4;}' unless defined(&MAXNODES);
    eval 'sub NUMA_NODEMASK () {0xf;}' unless defined(&NUMA_NODEMASK);
    eval 'sub MMU_PAGE_SIZES () {3;}' unless defined(&MMU_PAGE_SIZES);
    eval 'sub MMU_PAGESIZE () {0x1000;}' unless defined(&MMU_PAGESIZE);
    eval 'sub MMU_PAGESHIFT () {12;}' unless defined(&MMU_PAGESHIFT);
    if(!defined(&_ASM)) {
	eval 'sub MMU_PAGEOFFSET () {( &MMU_PAGESIZE-1);}' unless defined(&MMU_PAGEOFFSET);
    } else {
	eval 'sub MMU_PAGEOFFSET () { &_CONST( &MMU_PAGESIZE-1);}' unless defined(&MMU_PAGEOFFSET);
    }
    eval 'sub MMU_PAGEMASK () {(~ &MMU_PAGEOFFSET);}' unless defined(&MMU_PAGEMASK);
    eval 'sub PAGESIZE () {0x1000;}' unless defined(&PAGESIZE);
    eval 'sub PAGESHIFT () {12;}' unless defined(&PAGESHIFT);
    eval 'sub PAGEOFFSET () {( &PAGESIZE - 1);}' unless defined(&PAGEOFFSET);
    eval 'sub PAGEMASK () {(~ &PAGEOFFSET);}' unless defined(&PAGEMASK);
    eval 'sub DATA_ALIGN () { &PAGESIZE;}' unless defined(&DATA_ALIGN);
    if(defined(&__amd64)) {
	eval 'sub DEFAULTSTKSZ_NPGS () {5;}' unless defined(&DEFAULTSTKSZ_NPGS);
    }
 elsif(defined(&__i386)) {
	eval 'sub DEFAULTSTKSZ_NPGS () {3;}' unless defined(&DEFAULTSTKSZ_NPGS);
    }
    if(!defined(&_ASM)) {
	eval 'sub DEFAULTSTKSZ () {( &DEFAULTSTKSZ_NPGS *  &PAGESIZE);}' unless defined(&DEFAULTSTKSZ);
    } else {
	eval 'sub DEFAULTSTKSZ () { &_MUL( &DEFAULTSTKSZ_NPGS,  &PAGESIZE);}' unless defined(&DEFAULTSTKSZ);
    }
    eval 'sub KERNEL_TEXT_amd64 () { &UINT64_C(0xfffffffffb800000);}' unless defined(&KERNEL_TEXT_amd64);
    if(defined(&__i386)) {
	eval 'sub KERNEL_TEXT_i386 () { &ADDRESS_C(0xfe800000);}' unless defined(&KERNEL_TEXT_i386);
	eval 'sub KERNEL_TEXT_i386_xpv () {( &HYPERVISOR_VIRT_START_PAE - 3*  &ADDRESS_C(0x400000));}' unless defined(&KERNEL_TEXT_i386_xpv);
    }
    if(defined(&__amd64)) {
	eval 'sub KERNELBASE () { &ADDRESS_C(0xfffffd8000000000);}' unless defined(&KERNELBASE);
	eval 'sub KERNEL_REDZONE_SIZE () {(( &uintptr_t)1<< 39);}' unless defined(&KERNEL_REDZONE_SIZE);
	eval 'sub COREHEAP_BASE () { &ADDRESS_C(0xffffffffc0000000);}' unless defined(&COREHEAP_BASE);
	eval 'sub SEGKPM_BASE () { &ADDRESS_C(0xfffffe0000000000);}' unless defined(&SEGKPM_BASE);
	eval 'sub VALLOC_BASE () { &ADDRESS_C(0xffffff0000000000);}' unless defined(&VALLOC_BASE);
	eval 'sub SEGKPDEFSIZE () {(2 * 1024 * 1024 * 1024);}' unless defined(&SEGKPDEFSIZE);
	eval 'sub SEGKPMAXSIZE () {(8 * 1024 * 1024 * 1024);}' unless defined(&SEGKPMAXSIZE);
	eval 'sub SEGKPMINSIZE () {(200 * 1024* 1024);}' unless defined(&SEGKPMINSIZE);
	eval 'sub SEGZIOMINSIZE () {(400 * 1024* 1024);}' unless defined(&SEGZIOMINSIZE);
	eval 'sub SEGZIOMAXSIZE () {(512 * 1024 * 1024 * 1024);}' unless defined(&SEGZIOMAXSIZE);
	eval 'sub BOOT_KERNELHEAP_BASE () { &ADDRESS_C(0xffffffff00000000);}' unless defined(&BOOT_KERNELHEAP_BASE);
	eval 'sub PROMSTART () { &ADDRESS_C(0xffc00000);}' unless defined(&PROMSTART);
	eval 'sub KERNEL_TEXT () { &KERNEL_TEXT_amd64;}' unless defined(&KERNEL_TEXT);
	eval 'sub SEGDEBUGBASE () { &ADDRESS_C(0xffffffffff800000);}' unless defined(&SEGDEBUGBASE);
	eval 'sub SEGDEBUGSIZE () { &ADDRESS_C(0x400000);}' unless defined(&SEGDEBUGSIZE);
	if(defined(&__xpv)) {
	    eval 'sub USERLIMIT () { &ADDRESS_C(0x7fffffe00000);}' unless defined(&USERLIMIT);
	} else {
	    eval 'sub USERLIMIT () { &ADDRESS_C(0xfffffd7fffe00000);}' unless defined(&USERLIMIT);
	}
	if(defined(&bug_5074717_is_fixed)) {
	    eval 'sub USERLIMIT32 () { &ADDRESS_C(0xfffff000);}' unless defined(&USERLIMIT32);
	} else {
	    eval 'sub USERLIMIT32 () { &ADDRESS_C(0xfefff000);}' unless defined(&USERLIMIT32);
	}
    }
 elsif(defined(&__i386)) {
	if(defined(&DEBUG)) {
	    eval 'sub KERNELBASE () { &ADDRESS_C(0xc8000000);}' unless defined(&KERNELBASE);
	} else {
	    eval 'sub KERNELBASE () { &ADDRESS_C(0xd4000000);}' unless defined(&KERNELBASE);
	}
	eval 'sub KERNELBASE_MAX () { &ADDRESS_C(0xe0000000);}' unless defined(&KERNELBASE_MAX);
	eval 'sub KERNELBASE_ABI_MIN () { &ADDRESS_C(0xc0000000);}' unless defined(&KERNELBASE_ABI_MIN);
	eval 'sub KERNEL_REDZONE_SIZE () { &MAXBSIZE;}' unless defined(&KERNEL_REDZONE_SIZE);
	eval 'sub PROMSTART () { &ADDRESS_C(0xffc00000);}' unless defined(&PROMSTART);
	if(defined(&__xpv)) {
	    eval 'sub KERNEL_TEXT () { &KERNEL_TEXT_i386_xpv;}' unless defined(&KERNEL_TEXT);
	} else {
	    eval 'sub KERNEL_TEXT () { &KERNEL_TEXT_i386;}' unless defined(&KERNEL_TEXT);
	}
	eval 'sub SEGDEBUGBASE () {( &KERNEL_TEXT +  &ADDRESS_C(0x800000));}' unless defined(&SEGDEBUGBASE);
	eval 'sub SEGDEBUGSIZE () { &ADDRESS_C(0x400000);}' unless defined(&SEGDEBUGSIZE);
	eval 'sub USERLIMIT () { &KERNELBASE;}' unless defined(&USERLIMIT);
	eval 'sub USERLIMIT32 () { &USERLIMIT;}' unless defined(&USERLIMIT32);
    }
    if(!defined(&_ASM)) {
	eval 'sub DEBUG_INFO_VA () {( &KERNEL_TEXT -  &MMU_PAGESIZE);}' unless defined(&DEBUG_INFO_VA);
	eval 'sub GDT_VA () {( &DEBUG_INFO_VA -  &MMU_PAGESIZE);}' unless defined(&GDT_VA);
	eval 'sub IDT_VA () {( &GDT_VA -  &MMU_PAGESIZE);}' unless defined(&IDT_VA);
	eval 'sub KTSS_VA () {( &IDT_VA -  &MMU_PAGESIZE);}' unless defined(&KTSS_VA);
	eval 'sub DFTSS_VA () {( &KTSS_VA -  &MMU_PAGESIZE);}' unless defined(&DFTSS_VA);
	eval 'sub MISC_VA_BASE () {( &DFTSS_VA);}' unless defined(&MISC_VA_BASE);
	eval 'sub MISC_VA_SIZE () {( &KERNEL_TEXT -  &MISC_VA_BASE);}' unless defined(&MISC_VA_SIZE);
    }
    if(!defined(&_ASM)  && !defined(&_KMDB)) {
    }
    eval 'sub ARGSBASE () { &PROMSTART;}' unless defined(&ARGSBASE);
    eval 'sub MODTEXT () {(1024* 1024* 2);}' unless defined(&MODTEXT);
    eval 'sub MODDATA () {(1024* 300);}' unless defined(&MODDATA);
    eval 'sub HEAPTEXT_SIZE () {(64* 1024* 1024);}' unless defined(&HEAPTEXT_SIZE);
    eval 'sub T_STACKSZ () {2* &PAGESIZE;}' unless defined(&T_STACKSZ);
    eval 'sub STARTUP_STKSZ () {3* &PAGESIZE;}' unless defined(&STARTUP_STKSZ);
    eval 'sub BTISA () {1;}' unless defined(&BTISA);
    eval 'sub BTEISA () {2;}' unless defined(&BTEISA);
    eval 'sub BTMCA () {3;}' unless defined(&BTMCA);
    if(defined(&__cplusplus)) {
    }
}
1;
