require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MACHPRIVREGS_H)) {
    eval 'sub _SYS_MACHPRIVREGS_H () {1;}' unless defined(&_SYS_MACHPRIVREGS_H);
    require 'sys/hypervisor.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__amd64)) {
	eval 'sub CURVCPU {
	    my($r) = @_;
    	    eval q( &movq % &gs: &CPU_VCPU_INFO, $r);
	}' unless defined(&CURVCPU);
	eval 'sub CURTHREAD {
	    my($r) = @_;
    	    eval q( &movq % &gs: &CPU_THREAD, $r);
	}' unless defined(&CURTHREAD);
    }
 elsif(defined(&__i386)) {
	eval 'sub CURVCPU {
	    my($r) = @_;
    	    eval q( &movl % &gs: &CPU_VCPU_INFO, $r);
	}' unless defined(&CURVCPU);
	eval 'sub CURTHREAD {
	    my($r) = @_;
    	    eval q( &movl % &gs: &CPU_THREAD, $r);
	}' unless defined(&CURTHREAD);
    }
    eval 'sub XEN_TEST_EVENT_PENDING {
        my($r) = @_;
	    eval q( &testb $0xff,  &VCPU_INFO_EVTCHN_UPCALL_PENDING($r));
    }' unless defined(&XEN_TEST_EVENT_PENDING);
    eval 'sub XEN_SET_UPCALL_MASK {
        my($r) = @_;
	    eval q( &movb $1,  &VCPU_INFO_EVTCHN_UPCALL_MASK($r));
    }' unless defined(&XEN_SET_UPCALL_MASK);
    eval 'sub XEN_GET_UPCALL_MASK {
        my($r, $mask) = @_;
	    eval q( &movb  &VCPU_INFO_EVTCHN_UPCALL_MASK($r), $mask);
    }' unless defined(&XEN_GET_UPCALL_MASK);
    eval 'sub XEN_TEST_UPCALL_MASK {
        my($r) = @_;
	    eval q( &testb $1,  &VCPU_INFO_EVTCHN_UPCALL_MASK($r));
    }' unless defined(&XEN_TEST_UPCALL_MASK);
    eval 'sub XEN_CLEAR_UPCALL_MASK {
        my($r) = @_;
	    eval q( &ASSERT_UPCALL_MASK_IS_SET;  &movb $0,  &VCPU_INFO_EVTCHN_UPCALL_MASK($r));
    }' unless defined(&XEN_CLEAR_UPCALL_MASK);
    if(defined(&DEBUG)) {
	if(defined(&__amd64)) {
	    eval 'sub ASSERT_UPCALL_MASK_IS_SET () { &pushq % &r11;  &CURVCPU(% &r11);  &XEN_TEST_UPCALL_MASK(% &r11);  &jne 6 &f;  &cmpl $0,  &stistipanic(% &rip);  &jle 6 &f;  &movl $-1,  &stistipanic(% &rip);  &movq  &stistimsg(% &rip), % &rdi;  &xorl % &eax, % &eax;  &call  &panic; 6:  &pushq % &rax;  &pushq % &rbx;  &movl % &gs: &CPU_ID, % &eax;  &leaq .+0(% &rip), % &r11;  &leaq  &laststi(% &rip), % &rbx;  &movq % &r11, (% &rbx, % &rax, 8);  &popq % &rbx;  &popq % &rax;  &popq % &r11;}' unless defined(&ASSERT_UPCALL_MASK_IS_SET);
	    eval 'sub SAVE_CLI_LOCATION () { &pushq % &rax;  &pushq % &rbx;  &pushq % &rcx;  &movl % &gs: &CPU_ID, % &eax;  &leaq .+0(% &rip), % &rcx;  &leaq  &lastcli, % &rbx;  &movq % &rcx, (% &rbx, % &rax, 8);  &popq % &rcx;  &popq % &rbx;  &popq % &rax;;}' unless defined(&SAVE_CLI_LOCATION);
	}
 elsif(defined(&__i386)) {
	    eval 'sub ASSERT_UPCALL_MASK_IS_SET () { &pushl % &ecx;  &CURVCPU(% &ecx);  &XEN_TEST_UPCALL_MASK(% &ecx);  &jne 6 &f;  &cmpl $0,  &stistipanic;  &jle 6 &f;  &movl $-1,  &stistipanic;  &movl  &stistimsg, % &ecx;  &pushl % &ecx;  &call  &panic; 6:  &pushl % &eax;  &pushl % &ebx;  &movl % &gs: &CPU_ID, % &eax;  &leal .+0, % &ecx;  &leal  &laststi, % &ebx;  &movl % &ecx, (% &ebx, % &eax, 4);  &popl % &ebx;  &popl % &eax;  &popl % &ecx;}' unless defined(&ASSERT_UPCALL_MASK_IS_SET);
	    eval 'sub SAVE_CLI_LOCATION () { &pushl % &eax;  &pushl % &ebx;  &pushl % &ecx;  &movl % &gs: &CPU_ID, % &eax;  &leal .+0, % &ecx;  &leal  &lastcli, % &ebx;  &movl % &ecx, (% &ebx, % &eax, 4);  &popl % &ecx;  &popl % &ebx;  &popl % &eax;;}' unless defined(&SAVE_CLI_LOCATION);
	}
    } else {
	eval 'sub ASSERT_UPCALL_MASK_IS_SET () {1;}' unless defined(&ASSERT_UPCALL_MASK_IS_SET);
	eval 'sub SAVE_CLI_LOCATION () {1;}' unless defined(&SAVE_CLI_LOCATION);
    }
    eval 'sub KPREEMPT_DISABLE {
        my($t) = @_;
	    eval q( &addb $1,  &T_PREEMPT($t));
    }' unless defined(&KPREEMPT_DISABLE);
    eval 'sub KPREEMPT_ENABLE_NOKP {
        my($t) = @_;
	    eval q( &subb $1,  &T_PREEMPT($t));
    }' unless defined(&KPREEMPT_ENABLE_NOKP);
    eval 'sub CLI {
        my($r) = @_;
	    eval q( &CURTHREAD($r);  &KPREEMPT_DISABLE($r);  &CURVCPU($r);  &XEN_SET_UPCALL_MASK($r);  &SAVE_CLI_LOCATION;  &CURTHREAD($r);  &KPREEMPT_ENABLE_NOKP($r));
    }' unless defined(&CLI);
    eval 'sub CLIRET {
        my($r, $ret) = @_;
	    eval q( &CURTHREAD($r);  &KPREEMPT_DISABLE($r);  &CURVCPU($r);  &XEN_GET_UPCALL_MASK($r, $ret);  &XEN_SET_UPCALL_MASK($r);  &SAVE_CLI_LOCATION;  &CURTHREAD($r);  &KPREEMPT_ENABLE_NOKP($r));
    }' unless defined(&CLIRET);
    if(defined(&__amd64)) {
	eval 'sub STI_CLOBBER () { &CURVCPU(% &r11);  &ASSERT_UPCALL_MASK_IS_SET;  &movw $0x100, % &ax;  &movw $0, % &di;  &lock;  &cmpxchgw % &di,  &VCPU_INFO_EVTCHN_UPCALL_PENDING(% &r11);  &jz 7 &f;  &movl $ &__HYPERVISOR_sched_op, % &eax;  &movl $ &SCHEDOP_block, % &edi;  &pushq % &rsi;  &pushq % &rcx;  &pushq % &rdx;  &pushq % &r8;  &pushq % &r9;  &pushq % &r10;  &TRAP_INSTR;  &popq % &r10;  &popq % &r9;  &popq % &r8;  &popq % &rdx;  &popq % &rcx;  &popq % &rsi; 7:;}' unless defined(&STI_CLOBBER);
	eval 'sub STI () { &pushq % &r11;  &pushq % &rdi;  &pushq % &rax;  &STI_CLOBBER;  &popq % &rax;  &popq % &rdi;  &popq % &r11;}' unless defined(&STI);
    }
 elsif(defined(&__i386)) {
	eval 'sub STI_CLOBBER () { &CURVCPU(% &ecx);  &ASSERT_UPCALL_MASK_IS_SET;  &movw $0x100, % &ax;  &movw $0, % &bx;  &lock;  &cmpxchgw % &bx,  &VCPU_INFO_EVTCHN_UPCALL_PENDING(% &ecx);  &jz 7 &f;  &movl $ &__HYPERVISOR_sched_op, % &eax;  &movl $ &SCHEDOP_block, % &ebx;  &TRAP_INSTR; 7:;}' unless defined(&STI_CLOBBER);
	eval 'sub STI () { &pushl % &eax;  &pushl % &ebx;  &pushl % &ecx;  &STI_CLOBBER;  &popl % &ecx;  &popl % &ebx;  &popl % &eax;}' unless defined(&STI);
    }
    if(defined(&__amd64)) {
	eval 'sub IE_TO_EVENT_MASK {
	    my($rtmp, $rfl) = @_;
    	    eval q( &testq $ &PS_IE, $rfl;  &jnz 4 &f;  &CLI($rtmp);  &jmp 5 &f; 4:  &STI; 5:);
	}' unless defined(&IE_TO_EVENT_MASK);
	eval 'sub EVENT_MASK_TO_IE {
	    my($rtmp, $rfl) = @_;
    	    eval q( &andq $ &_BITNOT( &PS_IE), $rfl;  &CURVCPU($rtmp);  &XEN_TEST_UPCALL_MASK($rtmp);  &jnz 1 &f;  &orq $ &PS_IE, $rfl; 1:);
	}' unless defined(&EVENT_MASK_TO_IE);
    }
 elsif(defined(&__i386)) {
	eval 'sub IE_TO_EVENT_MASK {
	    my($rtmp, $rfl) = @_;
    	    eval q( &testl $ &PS_IE, $rfl;  &jnz 4 &f;  &CLI($rtmp);  &jmp 5 &f; 4:  &STI; 5:);
	}' unless defined(&IE_TO_EVENT_MASK);
	eval 'sub EVENT_MASK_TO_IE {
	    my($rtmp, $rfl) = @_;
    	    eval q( &andl $ &_BITNOT( &PS_IE), $rfl;  &CURVCPU($rtmp);  &XEN_TEST_UPCALL_MASK($rtmp);  &jnz 1 &f;  &orl $ &PS_IE, $rfl; 1:);
	}' unless defined(&EVENT_MASK_TO_IE);
    }
    if(defined(&__amd64)) {
	eval 'sub ENABLE_INTR_FLAGS () { &pushq $ &F_ON;  &popfq;  &STI;}' unless defined(&ENABLE_INTR_FLAGS);
    }
 elsif(defined(&__i386)) {
	eval 'sub ENABLE_INTR_FLAGS () { &pushl $ &F_ON;  &popfl;  &STI;}' unless defined(&ENABLE_INTR_FLAGS);
    }
    if(defined(&__amd64)) {
	if(defined(&DEBUG)) {
	    eval 'sub __ASSERT_NO_RUPDATE_PENDING () { &pushq % &r15;  &cmpw $ &KCS_SEL, 0x10(% &rsp);  &je 1 &f;  &movq % &gs: &CPU_THREAD, % &r15;  &movq  &T_LWP(% &r15), % &r15;  &testb $0x1,  &PCB_RUPDATE(% &r15);  &je 1 &f;  &ud2; 1:  &popq % &r15;}' unless defined(&__ASSERT_NO_RUPDATE_PENDING);
	} else {
	    eval 'sub __ASSERT_NO_RUPDATE_PENDING () {1;}' unless defined(&__ASSERT_NO_RUPDATE_PENDING);
	}
	eval 'sub HYPERVISOR_IRET {
	    my($flag) = @_;
    	    eval q( &__ASSERT_NO_RUPDATE_PENDING;  &pushq $$flag;  &pushq % &rcx;  &pushq % &r11;  &pushq % &rax;  &movl $ &__HYPERVISOR_iret, % &eax;  &syscall;  &ud2);
	}' unless defined(&HYPERVISOR_IRET);
	eval 'sub IRET () { &HYPERVISOR_IRET(0);}' unless defined(&IRET);
	eval 'sub SYSRETQ () { &HYPERVISOR_IRET(0);}' unless defined(&SYSRETQ);
	eval 'sub SYSRETL () { &ud2;}' unless defined(&SYSRETL);
	eval 'sub SWAPGS () {1;}' unless defined(&SWAPGS);
    }
 elsif(defined(&__i386)) {
	eval 'sub HYPERVISOR_IRET () { &pushl % &eax;  &movl $ &__HYPERVISOR_iret, % &eax; \'int\' $0x82;  &ud2;}' unless defined(&HYPERVISOR_IRET);
	eval 'sub IRET () { &HYPERVISOR_IRET;}' unless defined(&IRET);
	eval 'sub SYSRET () { &ud2;}' unless defined(&SYSRET);
    }
    if(defined(&__amd64)) {
	eval 'sub CLEAN_CS () { &movb $0,  &REGOFF_CS+4(% &rsp);}' unless defined(&CLEAN_CS);
    }
 elsif(defined(&__i386)) {
	eval 'sub CLEAN_CS () { &movb $0,  &REGOFF_CS+2(% &esp);}' unless defined(&CLEAN_CS);
    }
    if(defined(&__amd64)) {
	eval 'sub XPV_TRAP_POP () { &popq % &rcx;  &popq % &r11;}' unless defined(&XPV_TRAP_POP);
	eval 'sub XPV_TRAP_PUSH () { &pushq % &r11;  &pushq % &rcx;}' unless defined(&XPV_TRAP_PUSH);
    }
    if(defined(&__amd64)) {
	eval 'sub FAST_INTR_PUSH () { &INTGATE_INIT_KERNEL_FLAGS;  &popq % &rcx;  &popq % &r11;  &subq $ &REGOFF_RIP, % &rsp;  &movq % &rsi,  &REGOFF_RSI(% &rsp);  &movq % &rdi,  &REGOFF_RDI(% &rsp);  &CLEAN_CS;}' unless defined(&FAST_INTR_PUSH);
	eval 'sub FAST_INTR_POP () { &movq  &REGOFF_RSI(% &rsp), % &rsi;  &movq  &REGOFF_RDI(% &rsp), % &rdi;  &addq $ &REGOFF_RIP, % &rsp;}' unless defined(&FAST_INTR_POP);
	eval 'sub FAST_INTR_RETURN () { &ASSERT_UPCALL_MASK_IS_SET;  &HYPERVISOR_IRET(0);}' unless defined(&FAST_INTR_RETURN);
    }
 elsif(defined(&__i386)) {
	eval 'sub FAST_INTR_PUSH () { &cld;  &__SEGREGS_PUSH  &__SEGREGS_LOAD_KERNEL;}' unless defined(&FAST_INTR_PUSH);
	eval 'sub FAST_INTR_POP () { &__SEGREGS_POP;}' unless defined(&FAST_INTR_POP);
	eval 'sub FAST_INTR_RETURN () { &IRET;}' unless defined(&FAST_INTR_RETURN);
    }
    if(defined(&__amd64)) {
	eval 'sub STTS {
	    my($rtmp) = @_;
    	    eval q( &pushq % &rdi;  &movl $1, % &edi;  &call  &HYPERVISOR_fpu_taskswitch;  &popq % &rdi);
	}' unless defined(&STTS);
	eval 'sub CLTS () { &pushq % &rdi;  &xorl % &edi, % &edi;  &call  &HYPERVISOR_fpu_taskswitch;  &popq % &rdi;}' unless defined(&CLTS);
    }
 elsif(defined(&__i386)) {
	eval 'sub STTS {
	    my($r) = @_;
    	    eval q( &pushl $1;  &call  &HYPERVISOR_fpu_taskswitch;  &addl $4, % &esp);
	}' unless defined(&STTS);
	eval 'sub CLTS () { &pushl $0;  &call  &HYPERVISOR_fpu_taskswitch;  &addl $4, % &esp;}' unless defined(&CLTS);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
