require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PROC_H)) {
    eval 'sub _SYS_PROC_H () {1;}' unless defined(&_SYS_PROC_H);
    require 'sys/time.ph';
    require 'sys/thread.ph';
    require 'sys/cred.ph';
    require 'sys/user.ph';
    require 'sys/watchpoint.ph';
    require 'sys/timer.ph';
    if(defined(&__x86)) {
	require 'sys/tss.ph';
	require 'sys/segments.ph';
    }
    require 'sys/utrap.ph';
    require 'sys/model.ph';
    require 'sys/refstr.ph';
    require 'sys/avl.ph';
    require 'sys/rctl.ph';
    require 'sys/list.ph';
    require 'sys/avl.ph';
    require 'sys/door_impl.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_LP64)) {
    }
    if(defined(&__x86)) {
    }
    eval 'sub PROC_T () {1;}' unless defined(&PROC_T);
    if(defined(&_KERNEL)) {
    }
    eval 'sub p_pgrp () { ($p_pgidp->{pid_id});}' unless defined(&p_pgrp);
    eval 'sub p_pid () { ($p_pidp->{pid_id});}' unless defined(&p_pid);
    eval 'sub p_slot () { ($p_pidp->{pid_prslot});}' unless defined(&p_slot);
    eval 'sub p_detached () { ($p_pgidp->{pid_pgorphaned});}' unless defined(&p_detached);
    eval 'sub PID_HOLD {
        my($pidp) = @_;
	    eval q( &ASSERT( &MUTEX_HELD( &pidlock)); ++($pidp)-> &pid_ref;);
    }' unless defined(&PID_HOLD);
    eval 'sub PID_RELE {
        my($pidp) = @_;
	    eval q( &ASSERT( &MUTEX_HELD( &pidlock)); ($pidp)-> &pid_ref > 1? --($pidp)-> &pid_ref :  &pid_rele($pidp););
    }' unless defined(&PID_RELE);
    eval 'sub p_lock () { ($p_lockp->{pl_lock});}' unless defined(&p_lock);
    if(defined(&_KERNEL)) {
	eval 'sub PID_ALLOC_PROC () {0x1;}' unless defined(&PID_ALLOC_PROC);
    }
    eval 'sub SSLEEP () {1;}' unless defined(&SSLEEP);
    eval 'sub SRUN () {2;}' unless defined(&SRUN);
    eval 'sub SZOMB () {3;}' unless defined(&SZOMB);
    eval 'sub SSTOP () {4;}' unless defined(&SSTOP);
    eval 'sub SIDL () {5;}' unless defined(&SIDL);
    eval 'sub SONPROC () {6;}' unless defined(&SONPROC);
    eval 'sub SWAIT () {7;}' unless defined(&SWAIT);
    eval 'sub CLDPEND () {0x1;}' unless defined(&CLDPEND);
    eval 'sub CLDCONT () {0x2;}' unless defined(&CLDCONT);
    eval 'sub CLDNOSIGCHLD () {0x4;}' unless defined(&CLDNOSIGCHLD);
    eval 'sub CLDWAITPID () {0x8;}' unless defined(&CLDWAITPID);
    eval 'sub P_PR_TRACE () {0x1;}' unless defined(&P_PR_TRACE);
    eval 'sub P_PR_PTRACE () {0x2;}' unless defined(&P_PR_PTRACE);
    eval 'sub P_PR_FORK () {0x4;}' unless defined(&P_PR_FORK);
    eval 'sub P_PR_LOCK () {0x8;}' unless defined(&P_PR_LOCK);
    eval 'sub P_PR_ASYNC () {0x10;}' unless defined(&P_PR_ASYNC);
    eval 'sub P_PR_EXEC () {0x20;}' unless defined(&P_PR_EXEC);
    eval 'sub P_PR_BPTADJ () {0x40;}' unless defined(&P_PR_BPTADJ);
    eval 'sub P_PR_RUNLCL () {0x80;}' unless defined(&P_PR_RUNLCL);
    eval 'sub P_PR_KILLCL () {0x100;}' unless defined(&P_PR_KILLCL);
    eval 'sub SSYS () {0x1;}' unless defined(&SSYS);
    eval 'sub SEXITING () {0x2;}' unless defined(&SEXITING);
    eval 'sub SITBUSY () {0x4;}' unless defined(&SITBUSY);
    eval 'sub SFORKING () {0x8;}' unless defined(&SFORKING);
    eval 'sub SWATCHOK () {0x10;}' unless defined(&SWATCHOK);
    eval 'sub SKILLED () {0x100;}' unless defined(&SKILLED);
    eval 'sub SSCONT () {0x200;}' unless defined(&SSCONT);
    eval 'sub SZONETOP () {0x400;}' unless defined(&SZONETOP);
    eval 'sub SEXTKILLED () {0x800;}' unless defined(&SEXTKILLED);
    eval 'sub SUGID () {0x2000;}' unless defined(&SUGID);
    eval 'sub SEXECED () {0x4000;}' unless defined(&SEXECED);
    eval 'sub SJCTL () {0x10000;}' unless defined(&SJCTL);
    eval 'sub SNOWAIT () {0x20000;}' unless defined(&SNOWAIT);
    eval 'sub SVFORK () {0x40000;}' unless defined(&SVFORK);
    eval 'sub SVFWAIT () {0x80000;}' unless defined(&SVFWAIT);
    eval 'sub SEXITLWPS () {0x100000;}' unless defined(&SEXITLWPS);
    eval 'sub SHOLDFORK () {0x200000;}' unless defined(&SHOLDFORK);
    eval 'sub SHOLDFORK1 () {0x800000;}' unless defined(&SHOLDFORK1);
    eval 'sub SCOREDUMP () {0x1000000;}' unless defined(&SCOREDUMP);
    eval 'sub SMSACCT () {0x2000000;}' unless defined(&SMSACCT);
    eval 'sub SLWPWRAP () {0x4000000;}' unless defined(&SLWPWRAP);
    eval 'sub SAUTOLPG () {0x8000000;}' unless defined(&SAUTOLPG);
    eval 'sub SNOCD () {0x10000000;}' unless defined(&SNOCD);
    eval 'sub SHOLDWATCH () {0x20000000;}' unless defined(&SHOLDWATCH);
    eval 'sub SMSFORK () {0x40000000;}' unless defined(&SMSFORK);
    eval 'sub SDOCORE () {0x80000000;}' unless defined(&SDOCORE);
    eval 'sub PBWAIT () {0x1;}' unless defined(&PBWAIT);
    eval 'sub PEXITED () {0x2;}' unless defined(&PEXITED);
    eval 'sub PTOU {
        my($p) = @_;
	    eval q((($p)-> &p_user));
    }' unless defined(&PTOU);
    eval 'sub tracing {
        my($p, $sig) = @_;
	    eval q(( &sigismember(($p)-> &p_sigmask, $sig)));
    }' unless defined(&tracing);
    eval 'sub ISSIG {
        my($t, $why) = @_;
	    eval q( &ISSIG_FAST($t,  &ttolwp($t),  &ttoproc($t), $why));
    }' unless defined(&ISSIG);
    eval 'sub ISSIG_FAST {
        my($t, $lwp, $p, $why) = @_;
	    eval q(( &ISSIG_PENDING($t, $lwp, $p)  &&  &issig($why)));
    }' unless defined(&ISSIG_FAST);
    eval 'sub ISSIG_PENDING {
        my($t, $lwp, $p) = @_;
	    eval q((($lwp)-> &lwp_cursig |  &sigcheck(($p), ($t)) | ($p)-> &p_stopsig | ($t)-> &t_dtrace_stop | ($t)-> &t_dtrace_sig | (($t)-> &t_proc_flag & ( &TP_PRSTOP| &TP_HOLDLWP| &TP_CHKPT| &TP_PAUSE)) | (($p)-> &p_flag & ( &SEXITLWPS| &SKILLED| &SHOLDFORK1| &SHOLDWATCH))));
    }' unless defined(&ISSIG_PENDING);
    eval 'sub ISSTOP {
        my($sig) = @_;
	    eval q(( ($u->{u_signal[$sig}-1]) ==  &SIG_DFL  &&  &sigismember( &stopdefault, $sig)));
    }' unless defined(&ISSTOP);
    eval 'sub ISHOLD {
        my($p) = @_;
	    eval q((($p)-> &p_flag &  &SHOLDFORK));
    }' unless defined(&ISHOLD);
    eval 'sub MUSTRETURN {
        my($p, $t) = @_;
	    eval q(( &ISHOLD($p) | ($t)-> ($t_activefd->{a_stale})));
    }' unless defined(&MUSTRETURN);
    eval 'sub pr_watch_active {
        my($p) = @_;
	    eval q(( &avl_numnodes(($p)-> &p_warea) != 0));
    }' unless defined(&pr_watch_active);
    eval 'sub FORREAL () {0;}' unless defined(&FORREAL);
    eval 'sub JUSTLOOKING () {1;}' unless defined(&JUSTLOOKING);
    eval 'sub SUSPEND_NORMAL () {0;}' unless defined(&SUSPEND_NORMAL);
    eval 'sub SUSPEND_PAUSE () {1;}' unless defined(&SUSPEND_PAUSE);
    eval 'sub NOCLASS () {(-1);}' unless defined(&NOCLASS);
    eval 'sub CLASS_UNUSED () {(-2);}' unless defined(&CLASS_UNUSED);
    eval("sub LWP_STAT_INBLK () { 0; }") unless defined(&LWP_STAT_INBLK);
    eval("sub LWP_STAT_OUBLK () { 1; }") unless defined(&LWP_STAT_OUBLK);
    eval("sub LWP_STAT_MSGRCV () { 2; }") unless defined(&LWP_STAT_MSGRCV);
    eval("sub LWP_STAT_MSGSND () { 3; }") unless defined(&LWP_STAT_MSGSND);
    if(defined(&_KERNEL)) {
	if(defined(&__x86)) {
	}
	if(defined(&__sparcv9)) {
	    eval 'sub LWP_MMODEL_NEWLWP () {
	        eval q( &lwp_mmodel_newlwp());
	    }' unless defined(&LWP_MMODEL_NEWLWP);
	    eval 'sub LWP_MMODEL_SHARED_AS {
	        my($addr, $sz) = @_;
    		eval q( &lwp_mmodel_shared_as(($addr), ($sz)));
	    }' unless defined(&LWP_MMODEL_SHARED_AS);
	} else {
	    eval 'sub LWP_MMODEL_NEWLWP () {
	        eval q();
	    }' unless defined(&LWP_MMODEL_NEWLWP);
	    eval 'sub LWP_MMODEL_SHARED_AS {
	        my($addr, $sz) = @_;
    		eval q();
	    }' unless defined(&LWP_MMODEL_SHARED_AS);
	}
	if(defined(&_SYSCALL32_IMPL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
