require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_RESOURCE_H)) {
    eval 'sub _SYS_RESOURCE_H () {1;}' unless defined(&_SYS_RESOURCE_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    require 'sys/time.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PRIO_PROCESS () {0;}' unless defined(&PRIO_PROCESS);
    eval 'sub PRIO_PGRP () {1;}' unless defined(&PRIO_PGRP);
    eval 'sub PRIO_USER () {2;}' unless defined(&PRIO_USER);
    eval 'sub PRIO_GROUP () {3;}' unless defined(&PRIO_GROUP);
    eval 'sub PRIO_SESSION () {4;}' unless defined(&PRIO_SESSION);
    eval 'sub PRIO_LWP () {5;}' unless defined(&PRIO_LWP);
    eval 'sub PRIO_TASK () {6;}' unless defined(&PRIO_TASK);
    eval 'sub PRIO_PROJECT () {7;}' unless defined(&PRIO_PROJECT);
    eval 'sub PRIO_ZONE () {8;}' unless defined(&PRIO_ZONE);
    eval 'sub PRIO_CONTRACT () {9;}' unless defined(&PRIO_CONTRACT);
    eval 'sub RLIMIT_CPU () {0;}' unless defined(&RLIMIT_CPU);
    eval 'sub RLIMIT_FSIZE () {1;}' unless defined(&RLIMIT_FSIZE);
    eval 'sub RLIMIT_DATA () {2;}' unless defined(&RLIMIT_DATA);
    eval 'sub RLIMIT_STACK () {3;}' unless defined(&RLIMIT_STACK);
    eval 'sub RLIMIT_CORE () {4;}' unless defined(&RLIMIT_CORE);
    eval 'sub RLIMIT_NOFILE () {5;}' unless defined(&RLIMIT_NOFILE);
    eval 'sub RLIMIT_VMEM () {6;}' unless defined(&RLIMIT_VMEM);
    eval 'sub RLIMIT_AS () { &RLIMIT_VMEM;}' unless defined(&RLIMIT_AS);
    eval 'sub RLIM_NLIMITS () {7;}' unless defined(&RLIM_NLIMITS);
    if(defined(&_LP64)) {
	eval 'sub RLIM_INFINITY () {(( &rlim_t)-3);}' unless defined(&RLIM_INFINITY);
	eval 'sub RLIM_SAVED_MAX () {(( &rlim_t)-2);}' unless defined(&RLIM_SAVED_MAX);
	eval 'sub RLIM_SAVED_CUR () {(( &rlim_t)-1);}' unless defined(&RLIM_SAVED_CUR);
    } else {
	if((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 32) {
	    eval 'sub RLIM_INFINITY () {0x7fffffff;}' unless defined(&RLIM_INFINITY);
	    eval 'sub RLIM_SAVED_MAX () {0x7ffffffe;}' unless defined(&RLIM_SAVED_MAX);
	    eval 'sub RLIM_SAVED_CUR () {0x7ffffffd;}' unless defined(&RLIM_SAVED_CUR);
	} else {
	    eval 'sub RLIM_INFINITY () {(( &rlim_t)-3);}' unless defined(&RLIM_INFINITY);
	    eval 'sub RLIM_SAVED_MAX () {(( &rlim_t)-2);}' unless defined(&RLIM_SAVED_MAX);
	    eval 'sub RLIM_SAVED_CUR () {(( &rlim_t)-1);}' unless defined(&RLIM_SAVED_CUR);
	}
    }
    if(defined(&_SYSCALL32)) {
	eval 'sub RLIM32_INFINITY () {0x7fffffff;}' unless defined(&RLIM32_INFINITY);
	eval 'sub RLIM32_SAVED_MAX () {0x7ffffffe;}' unless defined(&RLIM32_SAVED_MAX);
	eval 'sub RLIM32_SAVED_CUR () {0x7ffffffd;}' unless defined(&RLIM32_SAVED_CUR);
    }
    if(defined(&_LARGEFILE64_SOURCE)) {
	eval 'sub RLIM64_INFINITY () {(( &rlim64_t)-3);}' unless defined(&RLIM64_INFINITY);
	eval 'sub RLIM64_SAVED_MAX () {(( &rlim64_t)-2);}' unless defined(&RLIM64_SAVED_MAX);
	eval 'sub RLIM64_SAVED_CUR () {(( &rlim64_t)-1);}' unless defined(&RLIM64_SAVED_CUR);
    }
    if(defined(&_LP64)) {
	eval 'sub RLIM_SAVED {
	    my($x) = @_;
    	    eval q((1));
	}' unless defined(&RLIM_SAVED);
	eval 'sub RLIM_NSAVED () { &RLIM_NLIMITS;}' unless defined(&RLIM_NSAVED);
    } else {
	eval 'sub RLIM_SAVED {
	    my($x) = @_;
    	    eval q(($x <=  &RLIMIT_FSIZE));
	}' unless defined(&RLIM_SAVED);
	eval 'sub RLIM_NSAVED () {( &RLIMIT_FSIZE + 1);}' unless defined(&RLIM_NSAVED);
    }
    eval 'sub _RUSAGESYS_GETRUSAGE () {0;}' unless defined(&_RUSAGESYS_GETRUSAGE);
    eval 'sub _RUSAGESYS_GETRUSAGE_CHLD () {1;}' unless defined(&_RUSAGESYS_GETRUSAGE_CHLD);
    eval 'sub _RUSAGESYS_GETRUSAGE_LWP () {2;}' unless defined(&_RUSAGESYS_GETRUSAGE_LWP);
    eval 'sub _RUSAGESYS_GETVMUSAGE () {3;}' unless defined(&_RUSAGESYS_GETVMUSAGE);
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_KERNEL)) {
	require 'sys/model.ph';
    } else {
	eval 'sub RUSAGE_SELF () {0;}' unless defined(&RUSAGE_SELF);
	eval 'sub RUSAGE_LWP () {1;}' unless defined(&RUSAGE_LWP);
	eval 'sub RUSAGE_CHILDREN () {-1;}' unless defined(&RUSAGE_CHILDREN);
	if(!defined(&_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub setrlimit () { &setrlimit64;}' unless defined(&setrlimit);
		eval 'sub getrlimit () { &getrlimit64;}' unless defined(&getrlimit);
		eval 'sub rlimit () { &rlimit64;}' unless defined(&rlimit);
	    }
	}
	if(defined(&_LP64)  && defined(&_LARGEFILE64_SOURCE)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub setrlimit64 () { &setrlimit;}' unless defined(&setrlimit64);
		eval 'sub getrlimit64 () { &getrlimit;}' unless defined(&getrlimit64);
		eval 'sub rlimit64 () { &rlimit;}' unless defined(&rlimit64);
	    }
	}
	if(defined(&_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)  && !defined(&__PRAGMA_REDEFINE_EXTNAME))) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
