require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TERMIOS_H)) {
    eval 'sub _SYS_TERMIOS_H () {1;}' unless defined(&_SYS_TERMIOS_H);
    require 'sys/feature_tests.ph';
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	require 'sys/ttydev.ph';
	require 'sys/time.ph';
    }
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	unless(defined(&_POSIX_VDISABLE)) {
	    eval 'sub _POSIX_VDISABLE () {0;}' unless defined(&_POSIX_VDISABLE);
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub CTRL {
	    my($c) = @_;
    	    eval q((($c)&037));
	}' unless defined(&CTRL);
	eval 'sub IBSHIFT () {16;}' unless defined(&IBSHIFT);
    }
    eval 'sub _NCC () {8;}' unless defined(&_NCC);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub NCC () { &_NCC;}' unless defined(&NCC);
    }
    eval 'sub NCCS () {19;}' unless defined(&NCCS);
    unless(defined(&_KERNEL)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	}
    }
    eval 'sub VINTR () {0;}' unless defined(&VINTR);
    eval 'sub VQUIT () {1;}' unless defined(&VQUIT);
    eval 'sub VERASE () {2;}' unless defined(&VERASE);
    eval 'sub VKILL () {3;}' unless defined(&VKILL);
    eval 'sub VEOF () {4;}' unless defined(&VEOF);
    eval 'sub VEOL () {5;}' unless defined(&VEOL);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub VEOL2 () {6;}' unless defined(&VEOL2);
    }
    eval 'sub VMIN () {4;}' unless defined(&VMIN);
    eval 'sub VTIME () {5;}' unless defined(&VTIME);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub VSWTCH () {7;}' unless defined(&VSWTCH);
    }
    eval 'sub VSTART () {8;}' unless defined(&VSTART);
    eval 'sub VSTOP () {9;}' unless defined(&VSTOP);
    eval 'sub VSUSP () {10;}' unless defined(&VSUSP);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub VDSUSP () {11;}' unless defined(&VDSUSP);
	eval 'sub VREPRINT () {12;}' unless defined(&VREPRINT);
	eval 'sub VDISCARD () {13;}' unless defined(&VDISCARD);
	eval 'sub VWERASE () {14;}' unless defined(&VWERASE);
	eval 'sub VLNEXT () {15;}' unless defined(&VLNEXT);
	eval 'sub VSTATUS () {16;}' unless defined(&VSTATUS);
	eval 'sub VCEOF () { &NCC;}' unless defined(&VCEOF);
	eval 'sub VCEOL () {( &NCC + 1);}' unless defined(&VCEOL);
	eval 'sub CNUL () {0;}' unless defined(&CNUL);
	eval 'sub CDEL () {0177;}' unless defined(&CDEL);
	eval 'sub CESC () {ord(\'\\\\\');}' unless defined(&CESC);
	eval 'sub CINTR () { &CTRL(ord(\'c\'));}' unless defined(&CINTR);
	eval 'sub CQUIT () {034;}' unless defined(&CQUIT);
	eval 'sub CERASE () {0177;}' unless defined(&CERASE);
	eval 'sub CKILL () { &CTRL(ord(\'u\'));}' unless defined(&CKILL);
	eval 'sub CEOT () {04;}' unless defined(&CEOT);
	eval 'sub CEOL () {0;}' unless defined(&CEOL);
	eval 'sub CEOL2 () {0;}' unless defined(&CEOL2);
	eval 'sub CEOF () {04;}' unless defined(&CEOF);
	eval 'sub CSTART () {021;}' unless defined(&CSTART);
	eval 'sub CSTOP () {023;}' unless defined(&CSTOP);
	eval 'sub CSWTCH () {032;}' unless defined(&CSWTCH);
	eval 'sub CNSWTCH () {0;}' unless defined(&CNSWTCH);
	eval 'sub CSUSP () { &CTRL(ord(\'z\'));}' unless defined(&CSUSP);
	eval 'sub CDSUSP () { &CTRL(ord(\'y\'));}' unless defined(&CDSUSP);
	eval 'sub CRPRNT () { &CTRL(ord(\'r\'));}' unless defined(&CRPRNT);
	eval 'sub CFLUSH () { &CTRL(ord(\'o\'));}' unless defined(&CFLUSH);
	eval 'sub CWERASE () { &CTRL(ord(\'w\'));}' unless defined(&CWERASE);
	eval 'sub CLNEXT () { &CTRL(ord(\'v\'));}' unless defined(&CLNEXT);
	eval 'sub CSTATUS () { &CTRL(ord(\'t\'));}' unless defined(&CSTATUS);
    }
    eval 'sub IGNBRK () {0000001;}' unless defined(&IGNBRK);
    eval 'sub BRKINT () {0000002;}' unless defined(&BRKINT);
    eval 'sub IGNPAR () {0000004;}' unless defined(&IGNPAR);
    eval 'sub PARMRK () {0000010;}' unless defined(&PARMRK);
    eval 'sub INPCK () {0000020;}' unless defined(&INPCK);
    eval 'sub ISTRIP () {0000040;}' unless defined(&ISTRIP);
    eval 'sub INLCR () {0000100;}' unless defined(&INLCR);
    eval 'sub IGNCR () {0000200;}' unless defined(&IGNCR);
    eval 'sub ICRNL () {0000400;}' unless defined(&ICRNL);
    if(!defined(&_POSIX_C_SOURCE) || (defined(&_XOPEN_SOURCE)  && !defined(&_XPG6)) || defined(&__EXTENSIONS__)) {
	eval 'sub IUCLC () {0001000;}' unless defined(&IUCLC);
    }
    eval 'sub IXON () {0002000;}' unless defined(&IXON);
    if(!defined(&_POSIX_C_SOURCE) || defined(&_XOPEN_SOURCE) || defined(&__EXTENSIONS__)) {
	eval 'sub IXANY () {0004000;}' unless defined(&IXANY);
    }
    eval 'sub IXOFF () {0010000;}' unless defined(&IXOFF);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub IMAXBEL () {0020000;}' unless defined(&IMAXBEL);
	eval 'sub DOSMODE () {0100000;}' unless defined(&DOSMODE);
    }
    eval 'sub OPOST () {0000001;}' unless defined(&OPOST);
    if(!defined(&_POSIX_C_SOURCE) || defined(&_XOPEN_SOURCE) || defined(&__EXTENSIONS__)) {
	if(!defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    eval 'sub OLCUC () {0000002;}' unless defined(&OLCUC);
	}
	eval 'sub ONLCR () {0000004;}' unless defined(&ONLCR);
	eval 'sub OCRNL () {0000010;}' unless defined(&OCRNL);
	eval 'sub ONOCR () {0000020;}' unless defined(&ONOCR);
	eval 'sub ONLRET () {0000040;}' unless defined(&ONLRET);
	eval 'sub OFILL () {0000100;}' unless defined(&OFILL);
	eval 'sub OFDEL () {0000200;}' unless defined(&OFDEL);
	eval 'sub NLDLY () {0000400;}' unless defined(&NLDLY);
	eval 'sub NL0 () {0;}' unless defined(&NL0);
	eval 'sub NL1 () {0000400;}' unless defined(&NL1);
	eval 'sub CRDLY () {0003000;}' unless defined(&CRDLY);
	eval 'sub CR0 () {0;}' unless defined(&CR0);
	eval 'sub CR1 () {0001000;}' unless defined(&CR1);
	eval 'sub CR2 () {0002000;}' unless defined(&CR2);
	eval 'sub CR3 () {0003000;}' unless defined(&CR3);
	eval 'sub TABDLY () {0014000;}' unless defined(&TABDLY);
	eval 'sub TAB0 () {0;}' unless defined(&TAB0);
	eval 'sub TAB1 () {0004000;}' unless defined(&TAB1);
	eval 'sub TAB2 () {0010000;}' unless defined(&TAB2);
	eval 'sub TAB3 () {0014000;}' unless defined(&TAB3);
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub XTABS () {0014000;}' unless defined(&XTABS);
    }
    if(!defined(&_POSIX_C_SOURCE) || defined(&_XOPEN_SOURCE) || defined(&__EXTENSIONS__)) {
	eval 'sub BSDLY () {0020000;}' unless defined(&BSDLY);
	eval 'sub BS0 () {0;}' unless defined(&BS0);
	eval 'sub BS1 () {0020000;}' unless defined(&BS1);
	eval 'sub VTDLY () {0040000;}' unless defined(&VTDLY);
	eval 'sub VT0 () {0;}' unless defined(&VT0);
	eval 'sub VT1 () {0040000;}' unless defined(&VT1);
	eval 'sub FFDLY () {0100000;}' unless defined(&FFDLY);
	eval 'sub FF0 () {0;}' unless defined(&FF0);
	eval 'sub FF1 () {0100000;}' unless defined(&FF1);
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub PAGEOUT () {0200000;}' unless defined(&PAGEOUT);
	eval 'sub WRAP () {0400000;}' unless defined(&WRAP);
	eval 'sub CBAUD () {0000017;}' unless defined(&CBAUD);
    }
    eval 'sub CSIZE () {0000060;}' unless defined(&CSIZE);
    eval 'sub CS5 () {0;}' unless defined(&CS5);
    eval 'sub CS6 () {0000020;}' unless defined(&CS6);
    eval 'sub CS7 () {0000040;}' unless defined(&CS7);
    eval 'sub CS8 () {0000060;}' unless defined(&CS8);
    eval 'sub CSTOPB () {0000100;}' unless defined(&CSTOPB);
    eval 'sub CREAD () {0000200;}' unless defined(&CREAD);
    eval 'sub PARENB () {0000400;}' unless defined(&PARENB);
    eval 'sub PARODD () {0001000;}' unless defined(&PARODD);
    eval 'sub HUPCL () {0002000;}' unless defined(&HUPCL);
    eval 'sub CLOCAL () {0004000;}' unless defined(&CLOCAL);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub RCV1EN () {0010000;}' unless defined(&RCV1EN);
	eval 'sub XMT1EN () {0020000;}' unless defined(&XMT1EN);
	eval 'sub LOBLK () {0040000;}' unless defined(&LOBLK);
	eval 'sub XCLUDE () {0100000;}' unless defined(&XCLUDE);
	eval 'sub CRTSXOFF () {010000000000;}' unless defined(&CRTSXOFF);
	eval 'sub CRTSCTS () {020000000000;}' unless defined(&CRTSCTS);
	eval 'sub CIBAUD () {03600000;}' unless defined(&CIBAUD);
	eval 'sub PAREXT () {04000000;}' unless defined(&PAREXT);
	eval 'sub CBAUDEXT () {010000000;}' unless defined(&CBAUDEXT);
	eval 'sub CIBAUDEXT () {020000000;}' unless defined(&CIBAUDEXT);
	eval 'sub CRTS_IFLOW () {010000000000;}' unless defined(&CRTS_IFLOW);
	eval 'sub CCTS_OFLOW () {020000000000;}' unless defined(&CCTS_OFLOW);
    }
    eval 'sub ISIG () {0000001;}' unless defined(&ISIG);
    eval 'sub ICANON () {0000002;}' unless defined(&ICANON);
    if(!defined(&_POSIX_C_SOURCE) || (defined(&_XOPEN_SOURCE)  && !defined(&_XPG6)) || defined(&__EXTENSIONS__)) {
	eval 'sub XCASE () {0000004;}' unless defined(&XCASE);
    }
    eval 'sub ECHO () {0000010;}' unless defined(&ECHO);
    eval 'sub ECHOE () {0000020;}' unless defined(&ECHOE);
    eval 'sub ECHOK () {0000040;}' unless defined(&ECHOK);
    eval 'sub ECHONL () {0000100;}' unless defined(&ECHONL);
    eval 'sub NOFLSH () {0000200;}' unless defined(&NOFLSH);
    eval 'sub TOSTOP () {0000400;}' unless defined(&TOSTOP);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub ECHOCTL () {0001000;}' unless defined(&ECHOCTL);
	eval 'sub ECHOPRT () {0002000;}' unless defined(&ECHOPRT);
	eval 'sub ECHOKE () {0004000;}' unless defined(&ECHOKE);
	eval 'sub DEFECHO () {0010000;}' unless defined(&DEFECHO);
	eval 'sub FLUSHO () {0020000;}' unless defined(&FLUSHO);
	eval 'sub PENDIN () {0040000;}' unless defined(&PENDIN);
    }
    eval 'sub IEXTEN () {0100000;}' unless defined(&IEXTEN);
    eval 'sub _TIOC () {(ord(\'T\')<<8);}' unless defined(&_TIOC);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub TIOC () { &_TIOC;}' unless defined(&TIOC);
	eval 'sub TCGETA () {( &_TIOC|1);}' unless defined(&TCGETA);
	eval 'sub TCSETA () {( &_TIOC|2);}' unless defined(&TCSETA);
	eval 'sub TCSETAW () {( &_TIOC|3);}' unless defined(&TCSETAW);
	eval 'sub TCSETAF () {( &_TIOC|4);}' unless defined(&TCSETAF);
	eval 'sub TCSBRK () {( &_TIOC|5);}' unless defined(&TCSBRK);
	eval 'sub TCXONC () {( &_TIOC|6);}' unless defined(&TCXONC);
	eval 'sub TCFLSH () {( &_TIOC|7);}' unless defined(&TCFLSH);
	eval 'sub TIOCKBON () {( &_TIOC|8);}' unless defined(&TIOCKBON);
	eval 'sub TIOCKBOF () {( &_TIOC|9);}' unless defined(&TIOCKBOF);
	eval 'sub KBENABLED () {( &_TIOC|10);}' unless defined(&KBENABLED);
	unless(defined(&IOCTYPE)) {
	    eval 'sub IOCTYPE () {0xff00;}' unless defined(&IOCTYPE);
	}
	eval 'sub TCDSET () {( &_TIOC|32);}' unless defined(&TCDSET);
	eval 'sub RTS_TOG () {( &_TIOC|33);}' unless defined(&RTS_TOG);
	eval 'sub TIOCGWINSZ () {( &_TIOC|104);}' unless defined(&TIOCGWINSZ);
	eval 'sub TIOCSWINSZ () {( &_TIOC|103);}' unless defined(&TIOCSWINSZ);
	eval 'sub TIOCGSOFTCAR () {( &_TIOC|105);}' unless defined(&TIOCGSOFTCAR);
	eval 'sub TIOCSSOFTCAR () {( &_TIOC|106);}' unless defined(&TIOCSSOFTCAR);
	eval 'sub TCGETS () {( &_TIOC|13);}' unless defined(&TCGETS);
	eval 'sub TCSETS () {( &_TIOC|14);}' unless defined(&TCSETS);
    }
    eval 'sub TCSANOW () {( &_TIOC|14);}' unless defined(&TCSANOW);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub TCSETSW () {( &_TIOC|15);}' unless defined(&TCSETSW);
    }
    eval 'sub TCSADRAIN () {( &_TIOC|15);}' unless defined(&TCSADRAIN);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub TCSETSF () {( &_TIOC|16);}' unless defined(&TCSETSF);
	eval 'sub TIOCGPPS () {( &_TIOC|125);}' unless defined(&TIOCGPPS);
	eval 'sub TIOCSPPS () {( &_TIOC|126);}' unless defined(&TIOCSPPS);
	eval 'sub TIOCGPPSEV () {( &_TIOC|127);}' unless defined(&TIOCGPPSEV);
	if(defined(&_SYSCALL32)) {
	}
    }
    eval 'sub TCSAFLUSH () {( &_TIOC|16);}' unless defined(&TCSAFLUSH);
    eval 'sub TCIFLUSH () {0;}' unless defined(&TCIFLUSH);
    eval 'sub TCOFLUSH () {1;}' unless defined(&TCOFLUSH);
    eval 'sub TCIOFLUSH () {2;}' unless defined(&TCIOFLUSH);
    eval 'sub TCOOFF () {0;}' unless defined(&TCOOFF);
    eval 'sub TCOON () {1;}' unless defined(&TCOON);
    eval 'sub TCIOFF () {2;}' unless defined(&TCIOFF);
    eval 'sub TCION () {3;}' unless defined(&TCION);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub tIOC () {(ord(\'t\')<<8);}' unless defined(&tIOC);
    }
    unless(defined(&_SYS_TTOLD_H)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    eval 'sub TIOCGETD () {( &tIOC|0);}' unless defined(&TIOCGETD);
	    eval 'sub TIOCSETD () {( &tIOC|1);}' unless defined(&TIOCSETD);
	    eval 'sub TIOCHPCL () {( &tIOC|2);}' unless defined(&TIOCHPCL);
	    eval 'sub TIOCGETP () {( &tIOC|8);}' unless defined(&TIOCGETP);
	    eval 'sub TIOCSETP () {( &tIOC|9);}' unless defined(&TIOCSETP);
	    eval 'sub TIOCSETN () {( &tIOC|10);}' unless defined(&TIOCSETN);
	    eval 'sub TIOCEXCL () {( &tIOC|13);}' unless defined(&TIOCEXCL);
	    eval 'sub TIOCNXCL () {( &tIOC|14);}' unless defined(&TIOCNXCL);
	    eval 'sub TIOCFLUSH () {( &tIOC|16);}' unless defined(&TIOCFLUSH);
	    eval 'sub TIOCSETC () {( &tIOC|17);}' unless defined(&TIOCSETC);
	    eval 'sub TIOCGETC () {( &tIOC|18);}' unless defined(&TIOCGETC);
	    eval 'sub TIOCLBIS () {( &tIOC|127);}' unless defined(&TIOCLBIS);
	    eval 'sub TIOCLBIC () {( &tIOC|126);}' unless defined(&TIOCLBIC);
	    eval 'sub TIOCLSET () {( &tIOC|125);}' unless defined(&TIOCLSET);
	    eval 'sub TIOCLGET () {( &tIOC|124);}' unless defined(&TIOCLGET);
	    eval 'sub TIOCSBRK () {( &tIOC|123);}' unless defined(&TIOCSBRK);
	    eval 'sub TIOCCBRK () {( &tIOC|122);}' unless defined(&TIOCCBRK);
	    eval 'sub TIOCSDTR () {( &tIOC|121);}' unless defined(&TIOCSDTR);
	    eval 'sub TIOCCDTR () {( &tIOC|120);}' unless defined(&TIOCCDTR);
	    eval 'sub TIOCSLTC () {( &tIOC|117);}' unless defined(&TIOCSLTC);
	    eval 'sub TIOCGLTC () {( &tIOC|116);}' unless defined(&TIOCGLTC);
	    eval 'sub TIOCOUTQ () {( &tIOC|115);}' unless defined(&TIOCOUTQ);
	    eval 'sub TIOCNOTTY () {( &tIOC|113);}' unless defined(&TIOCNOTTY);
	    eval 'sub TIOCSCTTY () {( &tIOC|132);}' unless defined(&TIOCSCTTY);
	    eval 'sub TIOCSTOP () {( &tIOC|111);}' unless defined(&TIOCSTOP);
	    eval 'sub TIOCSTART () {( &tIOC|110);}' unless defined(&TIOCSTART);
	    eval 'sub TIOCSILOOP () {( &tIOC|109);}' unless defined(&TIOCSILOOP);
	    eval 'sub TIOCCILOOP () {( &tIOC|108);}' unless defined(&TIOCCILOOP);
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub TIOCGPGRP () {( &tIOC|20);}' unless defined(&TIOCGPGRP);
	eval 'sub TIOCSPGRP () {( &tIOC|21);}' unless defined(&TIOCSPGRP);
	eval 'sub TIOCGSID () {( &tIOC|22);}' unless defined(&TIOCGSID);
	eval 'sub TIOCSTI () {( &tIOC|23);}' unless defined(&TIOCSTI);
	eval 'sub TIOCMSET () {( &tIOC|26);}' unless defined(&TIOCMSET);
	eval 'sub TIOCMBIS () {( &tIOC|27);}' unless defined(&TIOCMBIS);
	eval 'sub TIOCMBIC () {( &tIOC|28);}' unless defined(&TIOCMBIC);
	eval 'sub TIOCMGET () {( &tIOC|29);}' unless defined(&TIOCMGET);
	eval 'sub TIOCM_LE () {0001;}' unless defined(&TIOCM_LE);
	eval 'sub TIOCM_DTR () {0002;}' unless defined(&TIOCM_DTR);
	eval 'sub TIOCM_RTS () {0004;}' unless defined(&TIOCM_RTS);
	eval 'sub TIOCM_ST () {0010;}' unless defined(&TIOCM_ST);
	eval 'sub TIOCM_SR () {0020;}' unless defined(&TIOCM_SR);
	eval 'sub TIOCM_CTS () {0040;}' unless defined(&TIOCM_CTS);
	eval 'sub TIOCM_CAR () {0100;}' unless defined(&TIOCM_CAR);
	eval 'sub TIOCM_CD () { &TIOCM_CAR;}' unless defined(&TIOCM_CD);
	eval 'sub TIOCM_RNG () {0200;}' unless defined(&TIOCM_RNG);
	eval 'sub TIOCM_RI () { &TIOCM_RNG;}' unless defined(&TIOCM_RI);
	eval 'sub TIOCM_DSR () {0400;}' unless defined(&TIOCM_DSR);
	eval 'sub TIOCREMOTE () {( &tIOC|30);}' unless defined(&TIOCREMOTE);
	eval 'sub TIOCSIGNAL () {( &tIOC|31);}' unless defined(&TIOCSIGNAL);
	eval 'sub LDIOC () {(ord(\'D\')<<8);}' unless defined(&LDIOC);
	eval 'sub LDOPEN () {( &LDIOC|0);}' unless defined(&LDOPEN);
	eval 'sub LDCLOSE () {( &LDIOC|1);}' unless defined(&LDCLOSE);
	eval 'sub LDCHG () {( &LDIOC|2);}' unless defined(&LDCHG);
	eval 'sub LDGETT () {( &LDIOC|8);}' unless defined(&LDGETT);
	eval 'sub LDSETT () {( &LDIOC|9);}' unless defined(&LDSETT);
	eval 'sub LDSMAP () {( &LDIOC|110);}' unless defined(&LDSMAP);
	eval 'sub LDGMAP () {( &LDIOC|111);}' unless defined(&LDGMAP);
	eval 'sub LDNMAP () {( &LDIOC|112);}' unless defined(&LDNMAP);
	eval 'sub LDEMAP () {( &LDIOC|113);}' unless defined(&LDEMAP);
	eval 'sub LDDMAP () {( &LDIOC|114);}' unless defined(&LDDMAP);
	eval 'sub DIOC () {(ord(\'d\')<<8);}' unless defined(&DIOC);
	eval 'sub DIOCGETP () {( &DIOC|8);}' unless defined(&DIOCGETP);
	eval 'sub DIOCSETP () {( &DIOC|9);}' unless defined(&DIOCSETP);
	eval 'sub FIORDCHK () {((ord(\'f\')<<8)|3);}' unless defined(&FIORDCHK);
    }
    eval 'sub B0 () {0;}' unless defined(&B0);
    eval 'sub B50 () {1;}' unless defined(&B50);
    eval 'sub B75 () {2;}' unless defined(&B75);
    eval 'sub B110 () {3;}' unless defined(&B110);
    eval 'sub B134 () {4;}' unless defined(&B134);
    eval 'sub B150 () {5;}' unless defined(&B150);
    eval 'sub B200 () {6;}' unless defined(&B200);
    eval 'sub B300 () {7;}' unless defined(&B300);
    eval 'sub B600 () {8;}' unless defined(&B600);
    eval 'sub B1200 () {9;}' unless defined(&B1200);
    eval 'sub B1800 () {10;}' unless defined(&B1800);
    eval 'sub B2400 () {11;}' unless defined(&B2400);
    eval 'sub B4800 () {12;}' unless defined(&B4800);
    eval 'sub B9600 () {13;}' unless defined(&B9600);
    eval 'sub B19200 () {14;}' unless defined(&B19200);
    eval 'sub B38400 () {15;}' unless defined(&B38400);
    eval 'sub B57600 () {16;}' unless defined(&B57600);
    eval 'sub B76800 () {17;}' unless defined(&B76800);
    eval 'sub B115200 () {18;}' unless defined(&B115200);
    eval 'sub B153600 () {19;}' unless defined(&B153600);
    eval 'sub B230400 () {20;}' unless defined(&B230400);
    eval 'sub B307200 () {21;}' unless defined(&B307200);
    eval 'sub B460800 () {22;}' unless defined(&B460800);
    eval 'sub B921600 () {23;}' unless defined(&B921600);
    unless(defined(&_SYS_TTOLD_H)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
