require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TIME_H)) {
    eval 'sub _SYS_TIME_H () {1;}' unless defined(&_SYS_TIME_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	unless(defined(&_ASM)) {
	    if(!defined(&_TIME_T) || (defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
		eval 'sub _TIME_T () {1;}' unless defined(&_TIME_T);
	    }
	    unless(defined(&_SUSECONDS_T)) {
		eval 'sub _SUSECONDS_T () {1;}' unless defined(&_SUSECONDS_T);
	    }
	    if(defined(&_SYSCALL32)) {
		require 'sys/types32.ph';
		eval 'sub TIMEVAL32_TO_TIMEVAL {
		    my($tv, $tv32) = @_;
    		    eval q({ ($tv)-> &tv_sec = ( &time_t)($tv32)-> &tv_sec; ($tv)-> &tv_usec = ($tv32)-> &tv_usec; });
		}' unless defined(&TIMEVAL32_TO_TIMEVAL);
		eval 'sub TIMEVAL_TO_TIMEVAL32 {
		    my($tv32, $tv) = @_;
    		    eval q({ ($tv32)-> &tv_sec = ( &time32_t)($tv)-> &tv_sec; ($tv32)-> &tv_usec = ( &int32_t)($tv)-> &tv_usec; });
		}' unless defined(&TIMEVAL_TO_TIMEVAL32);
		eval 'sub TIME32_MAX () { &INT32_MAX;}' unless defined(&TIME32_MAX);
		eval 'sub TIME32_MIN () { &INT32_MIN;}' unless defined(&TIME32_MIN);
		eval 'sub TIMEVAL_OVERFLOW {
		    my($tv) = @_;
    		    eval q((($tv)-> &tv_sec <  &TIME32_MIN || ($tv)-> &tv_sec >  &TIME32_MAX));
		}' unless defined(&TIMEVAL_OVERFLOW);
	    }
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	unless(defined(&_ASM)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub DST_NONE () {0;}' unless defined(&DST_NONE);
	eval 'sub DST_USA () {1;}' unless defined(&DST_USA);
	eval 'sub DST_AUST () {2;}' unless defined(&DST_AUST);
	eval 'sub DST_WET () {3;}' unless defined(&DST_WET);
	eval 'sub DST_MET () {4;}' unless defined(&DST_MET);
	eval 'sub DST_EET () {5;}' unless defined(&DST_EET);
	eval 'sub DST_CAN () {6;}' unless defined(&DST_CAN);
	eval 'sub DST_GB () {7;}' unless defined(&DST_GB);
	eval 'sub DST_RUM () {8;}' unless defined(&DST_RUM);
	eval 'sub DST_TUR () {9;}' unless defined(&DST_TUR);
	eval 'sub DST_AUSTALT () {10;}' unless defined(&DST_AUSTALT);
	eval 'sub timerisset {
	    my($tvp) = @_;
    	    eval q((($tvp)-> &tv_sec || ($tvp)-> &tv_usec));
	}' unless defined(&timerisset);
	eval 'sub timercmp {
	    my($tvp, $uvp, $cmp) = @_;
    	    eval q(((($tvp)-> &tv_sec == ($uvp)-> &tv_sec) ? (($tvp)-> &tv_usec $cmp ($uvp)-> &tv_usec) : (($tvp)-> &tv_sec $cmp ($uvp)-> &tv_sec)));
	}' unless defined(&timercmp);
	eval 'sub timerclear {
	    my($tvp) = @_;
    	    eval q(($tvp)-> &tv_sec = ($tvp)-> &tv_usec = 0);
	}' unless defined(&timerclear);
	if(defined(&__lint)) {
	    eval 'sub timeradd {
	        my($tvp, $uvp, $vvp) = @_;
    		eval q( &do { ($vvp)-> &tv_sec = ($tvp)-> &tv_sec + ($uvp)-> &tv_sec; ($vvp)-> &tv_usec = ($tvp)-> &tv_usec + ($uvp)-> &tv_usec;  &if (($vvp)-> &tv_usec >= 1000000) { ($vvp)-> &tv_sec++; ($vvp)-> &tv_usec -= 1000000; } }  &while (($vvp)-> &tv_usec >= 1000000));
	    }' unless defined(&timeradd);
	    eval 'sub timersub {
	        my($tvp, $uvp, $vvp) = @_;
    		eval q( &do { ($vvp)-> &tv_sec = ($tvp)-> &tv_sec - ($uvp)-> &tv_sec; ($vvp)-> &tv_usec = ($tvp)-> &tv_usec - ($uvp)-> &tv_usec;  &if (($vvp)-> &tv_usec < 0) { ($vvp)-> &tv_sec--; ($vvp)-> &tv_usec += 1000000; } }  &while (($vvp)-> &tv_usec >= 1000000));
	    }' unless defined(&timersub);
	} else {
	    eval 'sub timeradd {
	        my($tvp, $uvp, $vvp) = @_;
    		eval q( &do { ($vvp)-> &tv_sec = ($tvp)-> &tv_sec + ($uvp)-> &tv_sec; ($vvp)-> &tv_usec = ($tvp)-> &tv_usec + ($uvp)-> &tv_usec;  &if (($vvp)-> &tv_usec >= 1000000) { ($vvp)-> &tv_sec++; ($vvp)-> &tv_usec -= 1000000; } }  &while (0));
	    }' unless defined(&timeradd);
	    eval 'sub timersub {
	        my($tvp, $uvp, $vvp) = @_;
    		eval q( &do { ($vvp)-> &tv_sec = ($tvp)-> &tv_sec - ($uvp)-> &tv_sec; ($vvp)-> &tv_usec = ($tvp)-> &tv_usec - ($uvp)-> &tv_usec;  &if (($vvp)-> &tv_usec < 0) { ($vvp)-> &tv_sec--; ($vvp)-> &tv_usec += 1000000; } }  &while (0));
	    }' unless defined(&timersub);
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub ITIMER_REAL () {0;}' unless defined(&ITIMER_REAL);
	eval 'sub ITIMER_VIRTUAL () {1;}' unless defined(&ITIMER_VIRTUAL);
	eval 'sub ITIMER_PROF () {2;}' unless defined(&ITIMER_PROF);
	eval 'sub ITIMER_REALPROF () {3;}' unless defined(&ITIMER_REALPROF);
	unless(defined(&_ASM)) {
	    if(defined(&_SYSCALL32)) {
		eval 'sub ITIMERVAL32_TO_ITIMERVAL {
		    my($itv, $itv32) = @_;
    		    eval q({  &TIMEVAL32_TO_TIMEVAL(($itv)-> &it_interval, ($itv32)-> &it_interval);  &TIMEVAL32_TO_TIMEVAL(($itv)-> &it_value, ($itv32)-> &it_value); });
		}' unless defined(&ITIMERVAL32_TO_ITIMERVAL);
		eval 'sub ITIMERVAL_TO_ITIMERVAL32 {
		    my($itv32, $itv) = @_;
    		    eval q({  &TIMEVAL_TO_TIMEVAL32(($itv32)-> &it_interval, ($itv)-> &it_interval);  &TIMEVAL_TO_TIMEVAL32(($itv32)-> &it_value, ($itv)-> &it_value); });
		}' unless defined(&ITIMERVAL_TO_ITIMERVAL32);
		eval 'sub ITIMERVAL_OVERFLOW {
		    my($itv) = @_;
    		    eval q(( &TIMEVAL_OVERFLOW(($itv)-> &it_interval) ||  &TIMEVAL_OVERFLOW(($itv)-> &it_value)));
		}' unless defined(&ITIMERVAL_OVERFLOW);
	    }
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub SEC () {1;}' unless defined(&SEC);
	eval 'sub MILLISEC () {1000;}' unless defined(&MILLISEC);
	eval 'sub MICROSEC () {1000000;}' unless defined(&MICROSEC);
	eval 'sub NANOSEC () {1000000000;}' unless defined(&NANOSEC);
	eval 'sub MSEC2NSEC {
	    my($m) = @_;
    	    eval q((( &hrtime_t)($m) * ( &NANOSEC /  &MILLISEC)));
	}' unless defined(&MSEC2NSEC);
	eval 'sub NSEC2MSEC {
	    my($n) = @_;
    	    eval q((($n) / ( &NANOSEC /  &MILLISEC)));
	}' unless defined(&NSEC2MSEC);
    }
    unless(defined(&_ASM)) {
	if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	    require 'sys/time_impl.ph';
	    require 'sys/mutex.ph';
	    eval 'sub TICK_TO_SEC {
	        my($tick) = @_;
    		eval q((($tick) /  &hz));
	    }' unless defined(&TICK_TO_SEC);
	    eval 'sub SEC_TO_TICK {
	        my($sec) = @_;
    		eval q((($sec) *  &hz));
	    }' unless defined(&SEC_TO_TICK);
	    eval 'sub TICK_TO_MSEC {
	        my($tick) = @_;
    		eval q(( &msec_per_tick ? ($tick) *  &msec_per_tick : ($tick) /  &tick_per_msec));
	    }' unless defined(&TICK_TO_MSEC);
	    eval 'sub MSEC_TO_TICK {
	        my($msec) = @_;
    		eval q(( &msec_per_tick ? ($msec) /  &msec_per_tick : ($msec) *  &tick_per_msec));
	    }' unless defined(&MSEC_TO_TICK);
	    eval 'sub MSEC_TO_TICK_ROUNDUP {
	        my($msec) = @_;
    		eval q(( &msec_per_tick ? (($msec) == 0? 0: (($msec) - 1) /  &msec_per_tick + 1) : ($msec) *  &tick_per_msec));
	    }' unless defined(&MSEC_TO_TICK_ROUNDUP);
	    eval 'sub TICK_TO_USEC {
	        my($tick) = @_;
    		eval q((($tick) *  &usec_per_tick));
	    }' unless defined(&TICK_TO_USEC);
	    eval 'sub USEC_TO_TICK {
	        my($usec) = @_;
    		eval q((($usec) /  &usec_per_tick));
	    }' unless defined(&USEC_TO_TICK);
	    eval 'sub USEC_TO_TICK_ROUNDUP {
	        my($usec) = @_;
    		eval q((($usec) == 0? 0:  &USEC_TO_TICK(($usec) - 1) + 1));
	    }' unless defined(&USEC_TO_TICK_ROUNDUP);
	    eval 'sub TICK_TO_NSEC {
	        my($tick) = @_;
    		eval q((( &hrtime_t)($tick) *  &nsec_per_tick));
	    }' unless defined(&TICK_TO_NSEC);
	    eval 'sub NSEC_TO_TICK {
	        my($nsec) = @_;
    		eval q((($nsec) /  &nsec_per_tick));
	    }' unless defined(&NSEC_TO_TICK);
	    eval 'sub NSEC_TO_TICK_ROUNDUP {
	        my($nsec) = @_;
    		eval q((($nsec) == 0? 0:  &NSEC_TO_TICK(($nsec) - 1) + 1));
	    }' unless defined(&NSEC_TO_TICK_ROUNDUP);
	    eval 'sub TICK_TO_TIMEVAL {
	        my($tick, $tvp) = @_;
    		eval q({  &clock_t  &__tmptck = ($tick); ($tvp)-> &tv_sec =  &TICK_TO_SEC( &__tmptck); ($tvp)-> &tv_usec =  &TICK_TO_USEC( &__tmptck -  &SEC_TO_TICK(($tvp)-> &tv_sec)); });
	    }' unless defined(&TICK_TO_TIMEVAL);
	    eval 'sub TICK_TO_TIMEVAL32 {
	        my($tick, $tvp) = @_;
    		eval q({  &clock_t  &__tmptck = ($tick);  &time_t  &__tmptm =  &TICK_TO_SEC( &__tmptck); ($tvp)-> &tv_sec = ( &time32_t) &__tmptm; ($tvp)-> &tv_usec =  &TICK_TO_USEC( &__tmptck -  &SEC_TO_TICK( &__tmptm)); });
	    }' unless defined(&TICK_TO_TIMEVAL32);
	    eval 'sub TICK_TO_TIMESTRUC {
	        my($tick, $tsp) = @_;
    		eval q({  &clock_t  &__tmptck = ($tick); ($tsp)-> &tv_sec =  &TICK_TO_SEC( &__tmptck); ($tsp)-> &tv_nsec =  &TICK_TO_NSEC( &__tmptck -  &SEC_TO_TICK(($tsp)-> &tv_sec)); });
	    }' unless defined(&TICK_TO_TIMESTRUC);
	    eval 'sub TICK_TO_TIMESTRUC32 {
	        my($tick, $tsp) = @_;
    		eval q({  &clock_t  &__tmptck = ($tick);  &time_t  &__tmptm =  &TICK_TO_SEC( &__tmptck); ($tsp)-> &tv_sec = ( &time32_t) &__tmptm; ($tsp)-> &tv_nsec =  &TICK_TO_NSEC( &__tmptck -  &SEC_TO_TICK( &__tmptm)); });
	    }' unless defined(&TICK_TO_TIMESTRUC32);
	    eval 'sub TIMEVAL_TO_TICK {
	        my($tvp) = @_;
    		eval q(( &SEC_TO_TICK(($tvp)-> &tv_sec) +  &USEC_TO_TICK(($tvp)-> &tv_usec)));
	    }' unless defined(&TIMEVAL_TO_TICK);
	    eval 'sub TIMESTRUC_TO_TICK {
	        my($tsp) = @_;
    		eval q(( &SEC_TO_TICK(($tsp)-> &tv_sec) +  &NSEC_TO_TICK(($tsp)-> &tv_nsec)));
	    }' unless defined(&TIMESTRUC_TO_TICK);
	    if(defined(&_SYSCALL32)) {
	    }
	}
	if(!defined(&_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	}
	if(!defined(&_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE) || defined(&__EXTENSIONS__)) {
	}
	if(!defined(&_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    if(defined(&_XPG4_2)) {
	    } else {
	    }
	}
	if(!defined(&_KERNEL)  && (defined(&_BSD_SOURCE) || defined(&__EXTENSIONS__))) {
	}
	if(!defined(&_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    if(defined(&_SVID_GETTOD)) {
	    } else {
	    }
	}
	if(!defined(&_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    if(defined(&_SVID_GETTOD)) {
	    } else {
	    }
	}
	if(!defined(&_BOOT)  && !defined(&_KERNEL)  && !defined(&_FAKE_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    require 'time.ph';
	}
	if(!defined(&_KERNEL)  && !defined(&_FAKE_KERNEL)  && !defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    require 'sys/select.ph';
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
