require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TIME_IMPL_H)) {
    eval 'sub _SYS_TIME_IMPL_H () {1;}' unless defined(&_SYS_TIME_IMPL_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	if(!defined(&_TIME_T) || (defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	    eval 'sub _TIME_T () {1;}' unless defined(&_TIME_T);
	}
	if(defined(&_SYSCALL32)) {
	    require 'sys/types32.ph';
	    eval 'sub TIMESPEC32_TO_TIMESPEC {
	        my($ts, $ts32) = @_;
    		eval q({ ($ts)-> &tv_sec = ( &time_t)($ts32)-> &tv_sec; ($ts)-> &tv_nsec = ($ts32)-> &tv_nsec; });
	    }' unless defined(&TIMESPEC32_TO_TIMESPEC);
	    eval 'sub TIMESPEC_TO_TIMESPEC32 {
	        my($ts32, $ts) = @_;
    		eval q({ ($ts32)-> &tv_sec = ( &time32_t)($ts)-> &tv_sec; ($ts32)-> &tv_nsec = ($ts)-> &tv_nsec; });
	    }' unless defined(&TIMESPEC_TO_TIMESPEC32);
	    eval 'sub TIMESPEC_OVERFLOW {
	        my($ts) = @_;
    		eval q((($ts)-> &tv_sec <  &TIME32_MIN || ($ts)-> &tv_sec >  &TIME32_MAX));
	    }' unless defined(&TIMESPEC_OVERFLOW);
	}
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    eval 'sub timestruc () { &timespec;}' unless defined(&timestruc);
	}
	if(defined(&_SYSCALL32)) {
	    eval 'sub ITIMERSPEC32_TO_ITIMERSPEC {
	        my($it, $it32) = @_;
    		eval q({  &TIMESPEC32_TO_TIMESPEC(($it)-> &it_interval, ($it32)-> &it_interval);  &TIMESPEC32_TO_TIMESPEC(($it)-> &it_value, ($it32)-> &it_value); });
	    }' unless defined(&ITIMERSPEC32_TO_ITIMERSPEC);
	    eval 'sub ITIMERSPEC_TO_ITIMERSPEC32 {
	        my($it32, $it) = @_;
    		eval q({  &TIMESPEC_TO_TIMESPEC32(($it32)-> &it_interval, ($it)-> &it_interval);  &TIMESPEC_TO_TIMESPEC32(($it32)-> &it_value, ($it)-> &it_value); });
	    }' unless defined(&ITIMERSPEC_TO_ITIMERSPEC32);
	    eval 'sub ITIMERSPEC_OVERFLOW {
	        my($it) = @_;
    		eval q(( &TIMESPEC_OVERFLOW(($it)-> &it_interval)  &&  &TIMESPEC_OVERFLOW(($it)-> &it_value)));
	    }' unless defined(&ITIMERSPEC_OVERFLOW);
	}
    }
    eval 'sub __CLOCK_REALTIME0 () {0;}' unless defined(&__CLOCK_REALTIME0);
    eval 'sub CLOCK_VIRTUAL () {1;}' unless defined(&CLOCK_VIRTUAL);
    eval 'sub CLOCK_THREAD_CPUTIME_ID () {2;}' unless defined(&CLOCK_THREAD_CPUTIME_ID);
    eval 'sub CLOCK_REALTIME () {3;}' unless defined(&CLOCK_REALTIME);
    eval 'sub CLOCK_MONOTONIC () {4;}' unless defined(&CLOCK_MONOTONIC);
    eval 'sub CLOCK_PROCESS_CPUTIME_ID () {5;}' unless defined(&CLOCK_PROCESS_CPUTIME_ID);
    eval 'sub CLOCK_HIGHRES () { &CLOCK_MONOTONIC;}' unless defined(&CLOCK_HIGHRES);
    eval 'sub CLOCK_PROF () { &CLOCK_THREAD_CPUTIME_ID;}' unless defined(&CLOCK_PROF);
    if(defined(&_KERNEL)) {
	eval 'sub CLOCK_MAX () {6;}' unless defined(&CLOCK_MAX);
    }
    eval 'sub TIMER_RELTIME () {0x;}' unless defined(&TIMER_RELTIME);
    eval 'sub TIMER_ABSTIME () {0x1;}' unless defined(&TIMER_ABSTIME);
    if(defined(&__cplusplus)) {
    }
}
1;
